import { _ as _extends } from './extends-e61fd370.js';
import { _ as _objectWithoutPropertiesLoose } from './objectWithoutPropertiesLoose-6856ddd5.js';
import { createElement } from 'react';
import { c as clsx } from './clsx.m-6243b874.js';
import { w as withStyles } from './withStyles-b3475989.js';
import { T as Typography } from './Typography-fd638108.js';
import { B as Button } from './Button-333b10ca.js';

const styles$1 = theme => {
  return {
    root: {
      transition: theme.transitions.create('color'),
      color: theme.palette.text.secondary,
      '&$selected': {
        color: theme.palette.text.primary
      }
    },
    selected: {}
  };
};

const PickersToolbarText = props => {
  const {
    className,
    classes,
    selected,
    value
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["className", "classes", "selected", "value"]);

  return /*#__PURE__*/createElement(Typography, _extends({
    className: clsx(classes.root, className, selected && classes.selected),
    component: "span"
  }, other), value);
};

var PickersToolbarText$1 = withStyles(styles$1, {
  name: 'MuiPickersToolbarText'
})(PickersToolbarText);

const styles = {
  root: {
    padding: 0,
    minWidth: '16px',
    textTransform: 'none'
  }
};

const ToolbarButton = props => {
  const {
    align,
    classes,
    className,
    selected,
    typographyClassName,
    value,
    variant
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["align", "classes", "className", "selected", "typographyClassName", "value", "variant"]);

  return /*#__PURE__*/createElement(Button, _extends({
    variant: "text",
    className: clsx(classes.root, className)
  }, other), /*#__PURE__*/createElement(PickersToolbarText$1, {
    align: align,
    className: typographyClassName,
    variant: variant,
    value: value,
    selected: selected
  }));
};

var PickersToolbarButton = withStyles(styles, {
  name: 'MuiPickersToolbarButton'
})(ToolbarButton);

export { PickersToolbarButton as P, PickersToolbarText$1 as a };
//# sourceMappingURL=PickersToolbarButton-77adf37a.js.map
