import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import React, { useCallback, useRef, useState, useEffect } from 'react';
import { E as EditIcon, s as styles$1 } from '../../EditableCell.module-fb3595c3.js';
import { g as getDefaultExportFromCjs, c as createCommonjsModule } from '../../_commonjsHelpers-41cdd1e7.js';
import { i as interopRequireWildcard, a as interopRequireDefault, c as createSvgIcon } from '../../createSvgIcon-08f23b3f.js';
import { C as ClearIcon } from '../../Clear-7316bc39.js';
import { s as styles } from '../../EnhancedTable.module-3f17e3a7.js';
import { u as useDispatch } from '../../index-1c8ec3e4.js';
import { b as setTableSelectable } from '../../actions-469e4403.js';
import { I as IconButton } from '../../IconButton-ccfdb4cc.js';
import { T as TextField } from '../../TextField-41fe2395.js';
import { M as MenuItem } from '../../MenuItem-16e73a5b.js';
import '../../style-inject.es-1f59c1d0.js';
import '../../createSvgIcon-141865d4.js';
import '../../extends-e61fd370.js';
import '../../objectWithoutPropertiesLoose-6856ddd5.js';
import '../../index-df27ca20.js';
import '../../clsx.m-6243b874.js';
import '../../experimentalStyled-9a0c9477.js';
import '../../ownerWindow-511cbe55.js';
import '../../ownerDocument-08286491.js';
import '../../requirePropFactory-762b28b9.js';
import '../../useId-9539b538.js';
import '../../unsupportedProp-90079dce.js';
import '../../useIsFocusVisible-7eb97459.js';
import '../../hoist-non-react-statics.cjs-887936b4.js';
import 'react-dom';
import '../../refType-2daf2908.js';
import '../../ButtonBase-fe35ba23.js';
import '../../emotion-react.esm-10db94ea.js';
import '../../assertThisInitialized-d8516fd7.js';
import '../../inheritsLoose-8d9312ec.js';
import '../../setPrototypeOf-38804714.js';
import '../../TransitionGroupContext-99ee4842.js';
import '../../elementTypeAcceptingRef-58d95132.js';
import '../../withStyles-6a29793a.js';
import '../../makeStyles-3f0becbd.js';
import '../../tiny-warning.esm-9caf1e37.js';
import '../../toConsumableArray-14d095fd.js';
import '../../exactProp-2b7ae831.js';
import '../../FormHelperText-9aa7662f.js';
import '../../utils-a2178b2f.js';
import '../../FormControlContext-3e99c910.js';
import '../../useFormControl-5a78d430.js';
import '../../InputLabel-dec1cb11.js';
import '../../Popover-16e53fc0.js';
import '../../isHostComponent-7b82e20e.js';
import '../../Grow-144e5c05.js';
import '../../Input-505624cb.js';
import '../../InputBase-ac030ecb.js';

var Save = createCommonjsModule(function (module, exports) {





Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React$1 = interopRequireWildcard(React);

var _createSvgIcon = interopRequireDefault(createSvgIcon);

var _default = (0, _createSvgIcon.default)( /*#__PURE__*/React$1.createElement("path", {
  d: "M17 3H5c-1.11 0-2 .9-2 2v14c0 1.1.89 2 2 2h14c1.1 0 2-.9 2-2V7l-4-4zm-5 16c-1.66 0-3-1.34-3-3s1.34-3 3-3 3 1.34 3 3-1.34 3-3 3zm3-10H5V5h10v4z"
}), 'Save');

exports.default = _default;
});

var SaveIcon = /*@__PURE__*/getDefaultExportFromCjs(Save);

var EditableCellSelectField = function (props) {
    var dispatch = useDispatch();
    var setSelectable = useCallback(function (value) {
        dispatch(setTableSelectable(value));
    }, [dispatch]);
    var initialValue = props.value, column = props.column, row = props.row, label = props.label, options = props.options, _a = props.valueKey, valueKey = _a === void 0 ? 'value' : _a, _b = props.labelKey, labelKey = _b === void 0 ? 'label' : _b;
    var inputEl = useRef(null);
    var divEl = useRef(null);
    var _c = useState(false), open = _c[0], setOpen = _c[1];
    var _d = React.useState(initialValue), value = _d[0], setValue = _d[1];
    useEffect(function () {
        if (inputEl.current) {
            inputEl.current.focus();
        }
    }, [open, inputEl]);
    var setEdit = function () {
        setOpen(true);
        setSelectable(true);
    };
    var updateData = function () {
        if (props.handleUpdate) {
            props.handleUpdate(value);
        }
        if (column.editData) {
            column.editData(row.original, value, column.id);
        }
        setOpen(false);
        setSelectable(false);
    };
    function cancel() {
        setValue(initialValue);
        setOpen(false);
        setSelectable(false);
    }
    var submitForm = function (event) {
        event.preventDefault();
        updateData();
        setSelectable(false);
    };
    React.useEffect(function () {
        setValue(initialValue);
    }, [initialValue]);
    var handleChange = function (event) {
        setValue(event.target.value);
    };
    return (jsx("div", __assign({ ref: divEl }, { children: !open ? (jsxs("div", __assign({ className: "dflex" }, { children: [jsxs("span", __assign({ className: "capitalize" }, { children: [label || initialValue, " "] }), void 0),
                jsx(IconButton, __assign({ className: styles.displayOnHover, size: "small", onClick: function () { return setEdit(); } }, { children: jsx(EditIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)) : (jsx("form", __assign({ onSubmit: submitForm }, { children: jsxs("div", __assign({ className: styles$1.inputContainer }, { children: [jsx(TextField, __assign({ select: true, value: value, onChange: handleChange, SelectProps: {
                            IconComponent: 'span',
                            MenuProps: {
                                anchorOrigin: {
                                    vertical: 'bottom',
                                    horizontal: 'left',
                                },
                                getContentAnchorEl: null,
                            },
                        } }, { children: options.map(function (option) { return (jsx(MenuItem, __assign({ value: option[valueKey] }, { children: option[labelKey] }), option[valueKey])); }) }), void 0),
                    jsxs("span", __assign({ className: styles$1.formButton }, { children: [jsx(IconButton, __assign({ size: "small", onClick: updateData }, { children: jsx(SaveIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0),
                            jsx(IconButton, __assign({ size: "small", onClick: function () { return cancel(); } }, { children: jsx(ClearIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)] }), void 0) }), void 0)) }), void 0));
};

export default EditableCellSelectField;
//# sourceMappingURL=EditableCellSelectField.js.map
