import { _ as __assign, d as __spreadArray } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import React, { useCallback, useRef, useState, useEffect } from 'react';
import { s as styles, E as EditIcon } from '../../EditableCell.module-fb3595c3.js';
import { C as ClearIcon } from '../../Clear-7316bc39.js';
import { s as styles$1 } from '../../EnhancedTable.module-3f17e3a7.js';
import { u as useDispatch } from '../../index-1c8ec3e4.js';
import { b as setTableSelectable } from '../../actions-469e4403.js';
import { D as DoneRoundedIcon } from '../../DoneRounded-17c0838b.js';
import AppTextField from '../../TextField/AppTextField.js';
import { I as IconButton } from '../../IconButton-ccfdb4cc.js';
import { A as Autocomplete } from '../../Autocomplete-5b4467ca.js';
import '../../_commonjsHelpers-41cdd1e7.js';
import '../../createSvgIcon-08f23b3f.js';
import '../../createSvgIcon-141865d4.js';
import '../../extends-e61fd370.js';
import '../../objectWithoutPropertiesLoose-6856ddd5.js';
import '../../index-df27ca20.js';
import '../../clsx.m-6243b874.js';
import '../../experimentalStyled-9a0c9477.js';
import '../../ownerWindow-511cbe55.js';
import '../../ownerDocument-08286491.js';
import '../../requirePropFactory-762b28b9.js';
import '../../useId-9539b538.js';
import '../../unsupportedProp-90079dce.js';
import '../../useIsFocusVisible-7eb97459.js';
import '../../style-inject.es-1f59c1d0.js';
import '../../hoist-non-react-statics.cjs-887936b4.js';
import 'react-dom';
import '../../TextField-41fe2395.js';
import '../../withStyles-6a29793a.js';
import '../../makeStyles-3f0becbd.js';
import '../../tiny-warning.esm-9caf1e37.js';
import '../../toConsumableArray-14d095fd.js';
import '../../inheritsLoose-8d9312ec.js';
import '../../setPrototypeOf-38804714.js';
import '../../assertThisInitialized-d8516fd7.js';
import '../../exactProp-2b7ae831.js';
import '../../refType-2daf2908.js';
import '../../FormHelperText-9aa7662f.js';
import '../../utils-a2178b2f.js';
import '../../FormControlContext-3e99c910.js';
import '../../useFormControl-5a78d430.js';
import '../../InputLabel-dec1cb11.js';
import '../../Popover-16e53fc0.js';
import '../../isHostComponent-7b82e20e.js';
import '../../Grow-144e5c05.js';
import '../../TransitionGroupContext-99ee4842.js';
import '../../elementTypeAcceptingRef-58d95132.js';
import '../../Input-505624cb.js';
import '../../InputBase-ac030ecb.js';
import '../../emotion-react.esm-10db94ea.js';
import '../../ButtonBase-fe35ba23.js';
import '../../Popper-2961f154.js';

var EditableCellSelectMultipleField = function (props) {
    var dispatch = useDispatch();
    var setSelectable = useCallback(function (value) {
        dispatch(setTableSelectable(value));
    }, [dispatch]);
    var initialValue = props.value, column = props.column, row = props.row, label = props.label, options = props.options, _a = props.valueKey, valueKey = _a === void 0 ? 'value' : _a, _b = props.labelKey, labelKey = _b === void 0 ? 'label' : _b;
    var inputEl = useRef(null);
    var divEl = useRef(null);
    var _c = useState(false), open = _c[0], setOpen = _c[1];
    var _d = React.useState(initialValue), listLabel = _d[0], setListLabel = _d[1];
    var _e = React.useState([]), listValue = _e[0], setListValue = _e[1];
    useEffect(function () {
        if (inputEl.current) {
            inputEl.current.focus();
        }
    }, [open, inputEl]);
    var setEdit = function () {
        setOpen(true);
        setSelectable(true);
    };
    var updateData = function () {
        if (column.editData) {
            column.editData(row.original, listValue);
        }
        setOpen(false);
        setSelectable(false);
    };
    function cancel() {
        setListLabel(initialValue);
        setOpen(false);
        setSelectable(false);
    }
    useEffect(function () {
        if (open) {
            setListLabel(initialValue);
        }
    }, [open]);
    var submitForm = function (event) {
        event.preventDefault();
        updateData();
        setSelectable(false);
    };
    return (jsx("div", __assign({ className: styles.cellWrap, ref: divEl }, { children: !open ? (jsxs("div", __assign({ className: styles.dflex }, { children: [jsxs("span", { children: [label || initialValue, " "] }, void 0),
                jsx(IconButton, __assign({ className: styles$1.displayOnHover, size: "small", onClick: function () { return setEdit(); } }, { children: jsx(EditIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)) : (jsx("form", __assign({ className: styles.multipleSelect, onSubmit: submitForm }, { children: jsxs("div", __assign({ className: styles.inputContainer }, { children: [jsx(Autocomplete, { classes: {
                            root: styles.autocompleteRoot,
                            inputRoot: styles.autocompleteInputRoot,
                            input: styles.autocompleteInput,
                        }, value: options.filter(function (item) { return listLabel.indexOf(item[labelKey]) > -1; }), multiple: true, options: options, disableClearable: true, getOptionLabel: function (option) { return option[labelKey]; }, renderInput: function (params) { return (jsx(AppTextField, __assign({ classes: {
                                root: styles.autocompleteTextForm,
                            } }, params, { autoFocus: true, InputLabelProps: { required: true } }), void 0)); }, onChange: function (event, listLabel) {
                            setListLabel(listLabel.reduce(function (acc, item) { return __spreadArray(__spreadArray([], acc), [item[labelKey]]); }, []));
                            setListValue(listLabel.reduce(function (acc, item) { return __spreadArray(__spreadArray([], acc), [item[valueKey]]); }, []));
                        }, clearOnBlur: true, freeSolo: true, size: "small", openOnFocus: true }, void 0),
                    jsxs("span", __assign({ className: styles.formButton }, { children: [jsx(IconButton, __assign({ size: "small", onClick: updateData }, { children: jsx(DoneRoundedIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0),
                            jsx(IconButton, __assign({ size: "small", onClick: function () { return cancel(); } }, { children: jsx(ClearIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)] }), void 0) }), void 0)) }), void 0));
};

export default EditableCellSelectMultipleField;
//# sourceMappingURL=EditableCellSelectMultipleField.js.map
