import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import React, { useCallback, useRef, useState, useEffect } from 'react';
import { u as useOnClickOutside } from '../../useOnClickOutside-5fbcb3ab.js';
import '../../ResizeObserver-da68295b.js';
import { s as styles, E as EditIcon } from '../../EditableCell.module-fb3595c3.js';
import { C as ClearIcon } from '../../Clear-7316bc39.js';
import { s as styles$1 } from '../../EnhancedTable.module-3f17e3a7.js';
import { u as useDispatch } from '../../index-1c8ec3e4.js';
import { b as setTableSelectable } from '../../actions-469e4403.js';
import { D as DoneRoundedIcon } from '../../DoneRounded-17c0838b.js';
import { I as IconButton } from '../../IconButton-ccfdb4cc.js';
import '../../_commonjsHelpers-41cdd1e7.js';
import '../../createSvgIcon-08f23b3f.js';
import '../../createSvgIcon-141865d4.js';
import '../../extends-e61fd370.js';
import '../../objectWithoutPropertiesLoose-6856ddd5.js';
import '../../index-df27ca20.js';
import '../../clsx.m-6243b874.js';
import '../../experimentalStyled-9a0c9477.js';
import '../../ownerWindow-511cbe55.js';
import '../../ownerDocument-08286491.js';
import '../../requirePropFactory-762b28b9.js';
import '../../useId-9539b538.js';
import '../../unsupportedProp-90079dce.js';
import '../../useIsFocusVisible-7eb97459.js';
import '../../style-inject.es-1f59c1d0.js';
import '../../hoist-non-react-statics.cjs-887936b4.js';
import 'react-dom';
import '../../refType-2daf2908.js';
import '../../ButtonBase-fe35ba23.js';
import '../../emotion-react.esm-10db94ea.js';
import '../../assertThisInitialized-d8516fd7.js';
import '../../inheritsLoose-8d9312ec.js';
import '../../setPrototypeOf-38804714.js';
import '../../TransitionGroupContext-99ee4842.js';
import '../../elementTypeAcceptingRef-58d95132.js';

var EditableCellTextField = function (props) {
    var dispatch = useDispatch();
    var setSelectable = useCallback(function (value) {
        dispatch(setTableSelectable(value));
    }, [dispatch]);
    var initialValue = props.value, column = props.column, row = props.row, inputProps = props.inputProps;
    var inputEl = useRef(null);
    var divEl = useRef(null);
    var _a = useState(false), open = _a[0], setOpen = _a[1];
    var _b = React.useState(initialValue), value = _b[0], setValue = _b[1];
    useOnClickOutside(divEl, function () { return cancel(); });
    useEffect(function () {
        if (inputEl.current) {
            inputEl.current.focus();
        }
    }, [open, inputEl]);
    var onChange = function (event) {
        setValue(event.target.value);
    };
    var setEdit = function () {
        setOpen(true);
        setSelectable(true);
    };
    var updateData = function () {
        if (props.handleUpdate) {
            props.handleUpdate(value);
        }
        if (column.editData) {
            column.editData(row.original, value, column.id);
        }
        setOpen(false);
        setSelectable(false);
    };
    function cancel() {
        setValue(initialValue);
        setOpen(false);
        setSelectable(false);
    }
    var submitForm = function (event) {
        event.preventDefault();
        updateData();
        setSelectable(false);
    };
    useEffect(function () {
        setValue(initialValue);
    }, [initialValue]);
    return (jsx("div", __assign({ ref: divEl }, { children: !(column.canEdit && open) ? (jsxs("div", __assign({ className: styles.dflex }, { children: [jsx("span", { children: props.children || initialValue }, void 0),
                column.canEdit && (jsx(IconButton, __assign({ className: styles$1.displayOnHover, size: "small", onClick: function () { return setEdit(); } }, { children: jsx(EditIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0))] }), void 0)) : (jsx("form", __assign({ onSubmit: submitForm }, { children: jsxs("div", __assign({ className: styles.inputContainer }, { children: [jsx("input", __assign({ ref: inputEl, type: "text", value: value, onChange: onChange, onClick: function () { return setEdit(); } }, inputProps), void 0),
                    jsxs("span", __assign({ className: styles.formButton }, { children: [jsx(IconButton, __assign({ type: 'submit', size: "small" }, { children: jsx(DoneRoundedIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0),
                            jsx(IconButton, __assign({ size: "small", onClick: function () { return cancel(); } }, { children: jsx(ClearIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)] }), void 0) }), void 0)) }), void 0));
};

export default EditableCellTextField;
//# sourceMappingURL=EditableCellTextField.js.map
