import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import { useCallback, useRef, useState, useEffect } from 'react';
import { T as TodayIcon } from '../../Today-8712b0e0.js';
import AppTextField from '../../TextField/AppTextField.js';
import { C as ClearIcon } from '../../Clear-7316bc39.js';
import { g as getDatabaseFormatType, s as getDatabaseFormatDateTime } from '../../moment-360196ce.js';
import { D as DoneRoundedIcon } from '../../DoneRounded-17c0838b.js';
import { s as styles, E as EditIcon } from '../../EditableCell.module-fb3595c3.js';
import { s as styles$1 } from '../../EnhancedTable.module-3f17e3a7.js';
import { u as useOnClickOutside } from '../../useOnClickOutside-5fbcb3ab.js';
import '../../ResizeObserver-da68295b.js';
import { u as useDispatch } from '../../index-1c8ec3e4.js';
import { b as setTableSelectable } from '../../actions-469e4403.js';
import { I as IconButton } from '../../IconButton-ccfdb4cc.js';
import { D as DatePicker } from '../../DatePicker-b0aa90e9.js';
import '../../_commonjsHelpers-41cdd1e7.js';
import '../../createSvgIcon-08f23b3f.js';
import '../../createSvgIcon-141865d4.js';
import '../../extends-e61fd370.js';
import '../../objectWithoutPropertiesLoose-6856ddd5.js';
import '../../index-df27ca20.js';
import '../../clsx.m-6243b874.js';
import '../../experimentalStyled-9a0c9477.js';
import '../../ownerWindow-511cbe55.js';
import '../../ownerDocument-08286491.js';
import '../../requirePropFactory-762b28b9.js';
import '../../useId-9539b538.js';
import '../../unsupportedProp-90079dce.js';
import '../../useIsFocusVisible-7eb97459.js';
import '../../style-inject.es-1f59c1d0.js';
import '../../TextField-41fe2395.js';
import '../../withStyles-6a29793a.js';
import '../../hoist-non-react-statics.cjs-887936b4.js';
import '../../makeStyles-3f0becbd.js';
import '../../tiny-warning.esm-9caf1e37.js';
import '../../toConsumableArray-14d095fd.js';
import '../../inheritsLoose-8d9312ec.js';
import '../../setPrototypeOf-38804714.js';
import '../../assertThisInitialized-d8516fd7.js';
import '../../exactProp-2b7ae831.js';
import '../../refType-2daf2908.js';
import '../../FormHelperText-9aa7662f.js';
import '../../utils-a2178b2f.js';
import '../../FormControlContext-3e99c910.js';
import '../../useFormControl-5a78d430.js';
import '../../InputLabel-dec1cb11.js';
import '../../Popover-16e53fc0.js';
import '../../isHostComponent-7b82e20e.js';
import '../../Grow-144e5c05.js';
import 'react-dom';
import '../../TransitionGroupContext-99ee4842.js';
import '../../elementTypeAcceptingRef-58d95132.js';
import '../../Input-505624cb.js';
import '../../InputBase-ac030ecb.js';
import '../../emotion-react.esm-10db94ea.js';
import '../../Typography-cbcc1b4d.js';
import '../../extendSxProp-f37d7304.js';
import '../../Grid-f6c53e5a.js';
import '../../Button-05f9d041.js';
import '../../ButtonBase-fe35ba23.js';
import '../../InputAdornment-081652f9.js';
import '../../makePickerWithState-5832a9db.js';
import '../../Popper-2961f154.js';

var EditableYear = function (props) {
    var dispatch = useDispatch();
    var setSelectable = useCallback(function (value) {
        dispatch(setTableSelectable(value));
    }, [dispatch]);
    var row = props.row, column = props.column, value = props.value;
    var divEl = useRef(null);
    useOnClickOutside(divEl, function () { return cancelTimePicker(); });
    var _a = useState(false), editDate = _a[0], setEditDate = _a[1];
    var _b = useState(value), selectedDate = _b[0], setSelectedDate = _b[1];
    function openTimePicker() {
        setEditDate(true);
        setSelectable(true);
    }
    function cancelTimePicker() {
        setSelectedDate(value);
        setEditDate(false);
    }
    useEffect(function () {
        setSelectedDate(value);
    }, [value]);
    function updateData() {
        if (column.editData) {
            column.editData(row.original, getDatabaseFormatType(selectedDate, 'YYYY'), column.id);
        }
        setEditDate(false);
    }
    return (jsx("div", __assign({ className: styles.formEditableDateTime }, { children: !editDate ? (jsxs("span", { children: [getDatabaseFormatType(selectedDate, 'YYYY'),
                jsx(IconButton, __assign({ className: styles$1.displayOnHover, size: "small", onClick: openTimePicker }, { children: jsx(EditIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }, void 0)) : (jsx(DatePicker, { value: selectedDate, onChange: function (newVal) {
                setSelectedDate(getDatabaseFormatDateTime(newVal));
            }, views: ['year'], openPickerIcon: jsx(TodayIcon, { color: 'secondary' }, void 0), mask: '____', inputFormat: 'YYYY', clearable: true, renderInput: function (props) {
                var _a;
                return (jsx(AppTextField, __assign({}, props, { InputLabelProps: { shrink: true }, InputProps: __assign(__assign({}, props.InputProps), { inputProps: __assign(__assign({}, ((props === null || props === void 0 ? void 0 : props.inputProps) || {})), { disabled: true }), endAdornment: (jsxs("div", __assign({ className: styles.formButton }, { children: [(_a = props.InputProps) === null || _a === void 0 ? void 0 : _a.endAdornment,
                                jsx(IconButton, __assign({ size: "small", onClick: updateData }, { children: jsx(DoneRoundedIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0),
                                jsx(IconButton, __assign({ size: "small", onClick: function () { return cancelTimePicker(); } }, { children: jsx(ClearIcon, { color: "primary", fontSize: "small" }, void 0) }), void 0)] }), void 0)) }), helperText: false }), void 0));
            } }, void 0)) }), void 0));
};

export default EditableYear;
//# sourceMappingURL=EditableYear.js.map
