import React from 'react';
import { TableOptions } from 'react-table';
import { TPagePagination, TPageParams } from 'AppModels';
declare type Props<T extends {
    id?: string;
}> = TableOptions<T> & {
    toolbarItems?: React.ReactElement;
    isLoading?: boolean;
    fetchData?: (payload: TPageParams) => void;
    pageInfo: TPagePagination;
    useSelection?: boolean;
    readonly localStorageKey: string;
    rightClickMenu?: React.ReactElement;
    useBlockingOverlay?: boolean;
    overlayConfig?: {
        displayFullscreen?: boolean;
    };
    alignItemsCenter?: boolean;
    defaultHiddenColumns?: string[];
};
declare const EnhancedTable: <T extends {
    id?: string | undefined;
}>(props: Props<T>) => JSX.Element;
export default EnhancedTable;
