import { d as __spreadArray, _ as __assign } from '../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import { forwardRef, createElement, useEffect, useCallback, useRef, useState } from 'react';
import { r as reactTable } from '../index-b6c1b619.js';
import { useSticky } from './plugins/useSticky.js';
import { T as TableToolbar, a as Toolbar } from '../TableToolbar-b8f3bd3b.js';
import { s as styles } from '../EnhancedTable.module-3f17e3a7.js';
import { c as clsx } from '../clsx.m-6243b874.js';
import { S as SelectableGroup, R as RowSelectable } from '../RowSelectable-aacb30f4.js';
import ReactTablePagination from './Pagination/ReactTablePagination.js';
import { C as ContextMenu, a as ContextMenuTrigger } from '../connectMenu-7261791b.js';
import { p as propTypes } from '../index-df27ca20.js';
import ConditionalWrap from '../utils/ConditionalWrap.js';
import { g as getFilters, a as getRouterQueries, l as lib, b as getPage, c as getPageSize } from '../GlobalFilter-b4bd8c6f.js';
import { c as config } from '../config-2233d325.js';
import { u as useDispatch } from '../index-1c8ec3e4.js';
import { s as selectMultiRows } from '../actions-469e4403.js';
import { g as getStorageInitialState, u as useMainResize, a as useSelector, t as tableSelectableSelector, T as TableContainer } from '../useMainResize-99da2cdb.js';
import { d as debounce_1 } from '../debounce-b9a8de1b.js';
import selectionHook from './plugins/selectionHook.js';
import EditableCellTextField from './EditableCell/EditableCellTextField.js';
import TableHeader from './components/TableHeader.js';
import { S as SELECTION_COLUMN_ID } from '../constants-cdb4cae7.js';
import { useLocalStorageTable } from './plugins/useLocalStorageTable.js';
import { useHiddenColumn } from './plugins/useHiddenColumn.js';
import { u as useLocation, a as useHistory } from '../react-router-5a8a5f30.js';
import { B as Backdrop } from '../Popover-16e53fc0.js';
import { _ as _objectWithoutPropertiesLoose } from '../objectWithoutPropertiesLoose-6856ddd5.js';
import { _ as _extends } from '../extends-e61fd370.js';
import { g as generateUtilityClass, a as generateUtilityClasses, e as experimentalStyled, u as useThemeProps, c as composeClasses, d as deepmerge, b as capitalize } from '../experimentalStyled-9a0c9477.js';
import { k as keyframes, c as css } from '../emotion-react.esm-10db94ea.js';
import { c as chainPropTypes } from '../refType-2daf2908.js';
import '../_commonjsHelpers-41cdd1e7.js';
import './Toolbar/ColumnDisplay.js';
import '../createSvgIcon-08f23b3f.js';
import '../createSvgIcon-141865d4.js';
import '../ownerWindow-511cbe55.js';
import '../ownerDocument-08286491.js';
import '../requirePropFactory-762b28b9.js';
import '../useId-9539b538.js';
import '../unsupportedProp-90079dce.js';
import '../useIsFocusVisible-7eb97459.js';
import '../ArrowDropDown-94d53692.js';
import '../isEqual-738b48ed.js';
import '../_MapCache-a3d3cd04.js';
import '../_isIndex-e6cb62f4.js';
import '../FormControlLabel-5b89f3db.js';
import '../useFormControl-5a78d430.js';
import '../FormControlContext-3e99c910.js';
import '../Typography-cbcc1b4d.js';
import '../extendSxProp-f37d7304.js';
import '../Checkbox-31af756d.js';
import '../SwitchBase-1231cda4.js';
import '../IconButton-ccfdb4cc.js';
import '../ButtonBase-fe35ba23.js';
import '../assertThisInitialized-d8516fd7.js';
import '../inheritsLoose-8d9312ec.js';
import '../setPrototypeOf-38804714.js';
import '../TransitionGroupContext-99ee4842.js';
import '../elementTypeAcceptingRef-58d95132.js';
import './Toolbar/FilterBox.js';
import '../Button-05f9d041.js';
import './Toolbar/LocalGlobalFilter.js';
import '../HighlightOff-fb35c071.js';
import '../lodash-348e7dda.js';
import '../useOnClickOutside-5fbcb3ab.js';
import '../Tooltip-73d2407b.js';
import '../Grow-144e5c05.js';
import 'react-dom';
import '../exactProp-2b7ae831.js';
import '../Popper-2961f154.js';
import '../InputBase-ac030ecb.js';
import '../utils-a2178b2f.js';
import '../isHostComponent-7b82e20e.js';
import '../makeStyles-5b784462.js';
import '../makeStyles-3f0becbd.js';
import '../tiny-warning.esm-9caf1e37.js';
import '../toConsumableArray-14d095fd.js';
import '../createStyles-8be7b6b1.js';
import '../style-inject.es-1f59c1d0.js';
import './Pagination/TablePaginationActions.js';
import '../KeyboardArrowRight-48df2583.js';
import '../TextField/AppTextField.js';
import '../TextField-41fe2395.js';
import '../withStyles-6a29793a.js';
import '../hoist-non-react-statics.cjs-887936b4.js';
import '../FormHelperText-9aa7662f.js';
import '../InputLabel-dec1cb11.js';
import '../Input-505624cb.js';
import '../Autocomplete-5b4467ca.js';
import '../MenuItem-16e73a5b.js';
import '../get-fc89bca9.js';
import '../_baseSet-fa34e586.js';
import '../ResizeObserver-da68295b.js';
import '../Checkbox/AppCheckBox.js';
import '../EditableCell.module-fb3595c3.js';
import '../Clear-7316bc39.js';
import '../DoneRounded-17c0838b.js';
import '../slicedToArray-9e59c773.js';

function getCircularProgressUtilityClass(slot) {
  return generateUtilityClass('MuiCircularProgress', slot);
}
const circularProgressClasses = generateUtilityClasses('MuiCircularProgress', ['root', 'determinate', 'indeterminate', 'colorPrimary', 'colorSecondary', 'svg', 'circle', 'circleDeterminate', 'circleIndeterminate', 'circleDisableShrink']);

let _ = t => t,
    _t,
    _t2,
    _t3,
    _t4;
const SIZE = 44;
const circularRotateKeyframe = keyframes(_t || (_t = _`
  0% {
    transform: rotate(0deg);
  }

  100% {
    transform: rotate(360deg);
  }
`));
const circularDashKeyframe = keyframes(_t2 || (_t2 = _`
  0% {
    stroke-dasharray: 1px, 200px;
    stroke-dashoffset: 0;
  }

  50% {
    stroke-dasharray: 100px, 200px;
    stroke-dashoffset: -15px;
  }

  100% {
    stroke-dasharray: 100px, 200px;
    stroke-dashoffset: -125px;
  }
`));

const overridesResolver = (props, styles) => {
  const {
    styleProps
  } = props;
  return deepmerge(_extends({}, styles[styleProps.variant], styles[`color${capitalize(styleProps.color)}`], {
    [`& .${circularProgressClasses.svg}`]: styles.svg,
    [`& .${circularProgressClasses.circle}`]: _extends({}, styles.circle, styles[`circle${capitalize(styleProps.variant)}`], styleProps.disableShrink && styles.circleDisableShrink)
  }), styles.root || {});
};

const useUtilityClasses = styleProps => {
  const {
    classes,
    variant,
    color,
    disableShrink
  } = styleProps;
  const slots = {
    root: ['root', variant, `color${capitalize(color)}`],
    svg: ['svg'],
    circle: ['circle', `circle${capitalize(variant)}`, disableShrink && 'circleDisableShrink']
  };
  return composeClasses(slots, getCircularProgressUtilityClass, classes);
};

const CircularProgressRoot = experimentalStyled('span', {}, {
  name: 'MuiCircularProgress',
  slot: 'Root',
  overridesResolver
})(({
  styleProps,
  theme
}) => _extends({
  /* Styles applied to the root element. */
  display: 'inline-block'
}, styleProps.variant === 'determinate' && {
  transition: theme.transitions.create('transform')
}, styleProps.color !== 'inherit' && {
  color: theme.palette[styleProps.color].main
}),
/* Styles applied to the root element if `variant="indeterminate"`. */
({
  styleProps
}) => styleProps.variant === 'indeterminate' && css(_t3 || (_t3 = _`
      animation: ${0} 1.4s linear infinite;
    `), circularRotateKeyframe));
const CircularProgressSVG = experimentalStyled('svg', {}, {
  name: 'MuiCircularProgress',
  slot: 'Svg'
})({
  /* Styles applied to the svg element. */
  display: 'block' // Keeps the progress centered

});
const CircularProgressCircle = experimentalStyled('circle', {}, {
  name: 'MuiCircularProgress',
  slot: 'Circle'
})(({
  styleProps,
  theme
}) => _extends({
  /* Styles applied to the `circle` svg path. */
  stroke: 'currentColor'
}, styleProps.variant === 'determinate' && {
  transition: theme.transitions.create('stroke-dashoffset')
}),
/* Styles applied to the `circle` svg path if `variant="indeterminate"`. */
({
  styleProps
}) => styleProps.variant === 'indeterminate' && css(_t4 || (_t4 = _`
      animation: ${0} 1.4s ease-in-out infinite;

      /* Some default value that looks fine waiting for the animation to kicks in. */
      stroke-dasharray: 80px, 200px;
      stroke-dashoffset: 0; /* Add the unit to fix a Edge 16 and below bug. */
    `), circularDashKeyframe));
/**
 * ## ARIA
 *
 * If the progress bar is describing the loading progress of a particular region of a page,
 * you should use `aria-describedby` to point to the progress bar, and set the `aria-busy`
 * attribute to `true` on that region until it has finished loading.
 */

const CircularProgress = /*#__PURE__*/forwardRef(function CircularProgress(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiCircularProgress'
  });

  const {
    className,
    color = 'primary',
    disableShrink = false,
    size = 40,
    style,
    thickness = 3.6,
    value = 0,
    variant = 'indeterminate'
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["className", "color", "disableShrink", "size", "style", "thickness", "value", "variant"]);

  const styleProps = _extends({}, props, {
    color,
    disableShrink,
    size,
    thickness,
    value,
    variant
  });

  const classes = useUtilityClasses(styleProps);
  const circleStyle = {};
  const rootStyle = {};
  const rootProps = {};

  if (variant === 'determinate') {
    const circumference = 2 * Math.PI * ((SIZE - thickness) / 2);
    circleStyle.strokeDasharray = circumference.toFixed(3);
    rootProps['aria-valuenow'] = Math.round(value);
    circleStyle.strokeDashoffset = `${((100 - value) / 100 * circumference).toFixed(3)}px`;
    rootStyle.transform = 'rotate(-90deg)';
  }

  return /*#__PURE__*/createElement(CircularProgressRoot, _extends({
    className: clsx(classes.root, className),
    style: _extends({
      width: size,
      height: size
    }, rootStyle, style),
    styleProps: styleProps,
    ref: ref,
    role: "progressbar"
  }, rootProps, other), /*#__PURE__*/createElement(CircularProgressSVG, {
    className: classes.svg,
    styleProps: styleProps,
    viewBox: `${SIZE / 2} ${SIZE / 2} ${SIZE} ${SIZE}`
  }, /*#__PURE__*/createElement(CircularProgressCircle, {
    className: classes.circle,
    style: circleStyle,
    styleProps: styleProps,
    cx: SIZE,
    cy: SIZE,
    r: (SIZE - thickness) / 2,
    fill: "none",
    strokeWidth: thickness
  })));
});
process.env.NODE_ENV !== "production" ? CircularProgress.propTypes = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------

  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypes.object,

  /**
   * @ignore
   */
  className: propTypes.string,

  /**
   * The color of the component. It supports those theme colors that make sense for this component.
   * @default 'primary'
   */
  color: propTypes
  /* @typescript-to-proptypes-ignore */
  .oneOfType([propTypes.oneOf(['inherit', 'primary', 'secondary']), propTypes.string]),

  /**
   * If `true`, the shrink animation is disabled.
   * This only works if variant is `indeterminate`.
   * @default false
   */
  disableShrink: chainPropTypes(propTypes.bool, props => {
    if (props.disableShrink && props.variant && props.variant !== 'indeterminate') {
      return new Error('Material-UI: You have provided the `disableShrink` prop ' + 'with a variant other than `indeterminate`. This will have no effect.');
    }

    return null;
  }),

  /**
   * The size of the component.
   * If using a number, the pixel unit is assumed.
   * If using a string, you need to provide the CSS unit, e.g '3rem'.
   * @default 40
   */
  size: propTypes.oneOfType([propTypes.number, propTypes.string]),

  /**
   * @ignore
   */
  style: propTypes.object,

  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypes.object,

  /**
   * The thickness of the circle.
   * @default 3.6
   */
  thickness: propTypes.number,

  /**
   * The value of the progress indicator for the determinate variant.
   * Value between 0 and 100.
   * @default 0
   */
  value: propTypes.number,

  /**
   * The variant to use.
   * Use indeterminate when there is no progress value.
   * @default 'indeterminate'
   */
  variant: propTypes.oneOf(['determinate', 'indeterminate'])
} : void 0;

function useChangeLocationQuery(instance, fetchData) {
    var setAllFilters = instance.setAllFilters, _a = instance.state, pageIndex = _a.pageIndex, pageSize = _a.pageSize, sortBy = _a.sortBy, filters = _a.filters;
    var location = useLocation();
    var history = useHistory();
    useEffect(function () {
        var currentQuery = getFilters(location.search);
        setAllFilters(currentQuery);
    }, [location.search, setAllFilters]);
    var fetchDataDebounce = reactTable.useAsyncDebounce(function () {
        var currentQuery = getRouterQueries(location.search);
        var query = {};
        if (Object.keys(filters).length) {
            query.filter = filters.reduce(function (obj, item) {
                obj[item.id] = item.value;
                return obj;
            }, {});
        }
        if (Object.keys(sortBy).length) {
            query.sort = sortBy.reduce(function (obj, item) {
                obj[item.id] = item.desc ? 'desc' : 'asc';
                return obj;
            }, {});
        }
        if (pageIndex) {
            query.page = pageIndex + 1;
        }
        if (pageSize !== config.perPage)
            query.per_page = pageSize;
        if (currentQuery.search && typeof currentQuery.search === 'string') {
            query.search = currentQuery.search;
        }
        var search = lib.stringify(query);
        var currentSearch = lib.stringify(currentQuery);
        if (search === currentSearch) {
            if (fetchData) {
                fetchData(query);
            }
            return;
        }
        else {
            history.push({
                search: search,
            });
        }
    }, 100);
    useEffect(function () {
        fetchDataDebounce();
    }, [pageIndex, pageSize, filters, sortBy, location, fetchDataDebounce]);
}

var defaultColumn = {
    Cell: EditableCellTextField,
};
var EnhancedTable = function (props) {
    var _a;
    var _b;
    var columns = props.columns, data = props.data, rightClickMenu = props.rightClickMenu, toolbarItems = props.toolbarItems, isLoading = props.isLoading, fetchData = props.fetchData, pageInfo = props.pageInfo, localStorageKey = props.localStorageKey, _c = props.useSelection, useSelection = _c === void 0 ? true : _c, _d = props.useBlockingOverlay, useBlockingOverlay = _d === void 0 ? true : _d, overlayConfig = props.overlayConfig, alignItemsCenter = props.alignItemsCenter, _e = props.defaultHiddenColumns, defaultHiddenColumns = _e === void 0 ? [] : _e;
    var location = useLocation();
    var pageUrl = getPage(location.search);
    var filterUrl = getFilters(location.search);
    var initState = getStorageInitialState(localStorageKey);
    if (!initState.hiddenColumns && defaultHiddenColumns.length > 0) {
        initState.hiddenColumns = defaultHiddenColumns;
    }
    var instance = reactTable.useTable.apply(void 0, __spreadArray([{
            columns: columns,
            tableKey: localStorageKey,
            data: data,
            defaultColumn: defaultColumn,
            initialState: __assign({ pageIndex: pageUrl ? pageUrl - 1 : 0, pageSize: getPageSize(location.search) || config.perPage, filters: filterUrl }, initState),
            manualSortBy: true,
            manualFilters: true,
            manualPagination: true,
            pageCount: 100,
        }, reactTable.useFlexLayout,
        reactTable.useResizeColumns,
        reactTable.useFilters,
        reactTable.useColumnOrder,
        reactTable.useGlobalFilter,
        reactTable.useSortBy,
        reactTable.usePagination,
        reactTable.useRowSelect,
        useSticky,
        useLocalStorageTable,
        useHiddenColumn], (useSelection ? [selectionHook] : [])));
    var getTableProps = instance.getTableProps, prepareRow = instance.prepareRow, page = instance.page, gotoPage = instance.gotoPage, setPageSize = instance.setPageSize, selectedFlatRows = instance.selectedFlatRows, toggleAllRowsSelected = instance.toggleAllRowsSelected, rows = instance.rows, _f = instance.state, pageIndex = _f.pageIndex, pageSize = _f.pageSize;
    var mainWidth = useMainResize().width;
    var stableColumns = __spreadArray([
        SELECTION_COLUMN_ID
    ], instance.allColumns
        .filter(function (item) { return item.isStable; })
        .map(function (item) { return item.id; }));
    var dispatch = useDispatch();
    useChangeLocationQuery(instance, fetchData);
    var delayedQuery = useCallback(debounce_1(function (rows) {
        dispatch(selectMultiRows(rows));
    }, 500), [dispatch]);
    useEffect(function () {
        var rows = selectedFlatRows.map(function (item) { return item.original; });
        delayedQuery(rows);
    }, [delayedQuery, selectedFlatRows]);
    var tableRef = useRef(null);
    useEffect(function () {
        if (tableRef.current) {
            tableRef.current.scrollIntoView({ behavior: 'smooth' });
        }
    }, [pageIndex, pageSize]);
    var Pagination = (jsx(ReactTablePagination, { gotoPage: gotoPage, pageIndex: pageIndex, setPageSize: setPageSize, pageSize: pageSize, pageTotal: pageInfo.total }, void 0));
    var isSelectable = useSelector(tableSelectableSelector);
    var _g = useState(null), previousRow = _g[0], setPreviousRow = _g[1];
    var handleSelectableGroupFinish = function (selectedRows) {
        if (selectedRows && selectedRows.length > 0) {
            selectedRows.forEach(function (row) {
                if (row && row.props) {
                    row.props.row.toggleRowSelected();
                }
            });
        }
    };
    return (jsxs(TableContainer, __assign({ className: clsx(styles.tableContainer, useBlockingOverlay &&
            !(overlayConfig === null || overlayConfig === void 0 ? void 0 : overlayConfig.displayFullscreen) &&
            styles.positionRelative), style: { width: instance.totalVisibleColumnsWidth } }, { children: [jsx(Backdrop, __assign({ className: clsx(styles.backdrop, (_b = overlayConfig === null || overlayConfig === void 0 ? void 0 : overlayConfig.displayFullscreen) !== null && _b !== void 0 ? _b : styles.positionAbsolute), open: !!isLoading && useBlockingOverlay }, { children: jsx(CircularProgress, { color: "inherit" }, void 0) }), void 0),
            jsx(TableToolbar, { width: mainWidth, instance: instance, stableColumns: stableColumns, toolbarItems: toolbarItems, pagination: Pagination, defaultHiddenColumns: defaultHiddenColumns }, void 0),
            jsx("div", __assign({ className: styles.actionScroll }, { children: jsxs(SelectableGroup, __assign({ className: styles.fixWidthScroll, selectboxClassName: 'selectable-selectbox', disabled: isSelectable, deselectOnEsc: true, selectOnClick: false, enableDeselect: true, allowClickWithoutSelected: false, tolerance: 5, resetOnStart: true, onSelectionFinish: handleSelectableGroupFinish, ignoreList: ['.th'] }, { children: [rightClickMenu && (jsx(ContextMenu, __assign({ id: "same_unique_identifier", className: styles.contextMenu }, { children: rightClickMenu }), void 0)),
                        jsx("div", __assign({ className: clsx(styles.tableBodyScroll, styles.noHighLight) }, { children: jsx(ConditionalWrap, __assign({ condition: !!rightClickMenu, wrap: function (children) { return (jsx(ContextMenuTrigger, __assign({ id: 'same_unique_identifier', holdToDisplay: -1 }, { children: children }), void 0)); } }, { children: jsxs("div", __assign({ ref: tableRef }, getTableProps(), { className: clsx(styles.table, styles.sticky) }, { children: [jsx(TableHeader, { instance: instance, stableColumns: stableColumns }, void 0),
                                        jsx("div", __assign({}, instance.getTableBodyProps(), { style: { width: instance.totalVisibleColumnsWidth }, className: clsx((_a = {},
                                                _a[styles.alignItemsCenter] = data.length && alignItemsCenter,
                                                _a)) }, { children: data.length > 0 ? (page.map(function (row) {
                                                prepareRow(row);
                                                return (jsx(RowSelectable, __assign({}, row.getRowProps(), { row: row, previousRow: previousRow, setPreviousRow: setPreviousRow, toggleAllRowsSelected: toggleAllRowsSelected, rows: rows }), void 0));
                                            })) : (jsx("div", __assign({ className: "p-14" }, { children: "No record found" }), void 0)) }), void 0)] }), void 0) }), void 0) }), void 0)] }), void 0) }), void 0),
            jsxs(Toolbar, __assign({ className: clsx(styles.toolbar), style: { width: mainWidth } }, { children: [selectedFlatRows.length > 0 && (jsxs("span", { children: [selectedFlatRows.length, " Selected Rows"] }, void 0)), Pagination] }), void 0)] }), void 0));
};

export default EnhancedTable;
//# sourceMappingURL=EnhancedTable.js.map
