import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import React, { createElement, memo, forwardRef, Fragment, useRef, useContext, useEffect, useCallback, useState, useMemo } from 'react';
import { s as styles$4 } from '../../EnhancedTable.module-3f17e3a7.js';
import { u as useUtils, P as PickersToolbar, t as areDayPropsEqual, D as DAY_MARGIN, w as PickersDay, e as defaultMinDate, f as defaultMaxDate, x as PickersCalendarHeader, y as PickersCalendar, z as doNothing, A as isWithinRange, B as isStartOfRange, C as isEndOfRange, W as WrapperVariantContext, E as executeInTheNextEventLoopTick, F as useMaskedInput, G as mergeRefs, H as useNextMonthDisabled, I as usePreviousMonthDisabled, J as PickersArrowSwitcher, L as useCalendarState, N as isRangeValid, O as MobileKeyboardInputView, Q as defaultReduceAnimations, c as useParsedDate, j as usePickerState, m as makeValidationHook, R as validateDateRange, n as makeWrapperComponent, S as parseRangeInputValue, M as MobileWrapper, a as getDatabaseFormatDate } from '../../moment-360196ce.js';
import { C as ClearIcon } from '../../Clear-7316bc39.js';
import { p as propTypes } from '../../index-df27ca20.js';
import { _ as _extends } from '../../extends-e61fd370.js';
import { _ as _objectWithoutPropertiesLoose } from '../../objectWithoutPropertiesLoose-6856ddd5.js';
import { P as PickersToolbarButton } from '../../PickersToolbarButton-bcb0d556.js';
import { w as withStyles } from '../../withStyles-6a29793a.js';
import { T as Typography } from '../../Typography-cbcc1b4d.js';
import { c as clsx } from '../../clsx.m-6243b874.js';
import { f as alpha, u as useThemeProps } from '../../experimentalStyled-9a0c9477.js';
import { T as TextField } from '../../TextField-41fe2395.js';
import { I as InputAdornment } from '../../InputAdornment-081652f9.js';
import { I as IconButton } from '../../IconButton-ccfdb4cc.js';
import '../../style-inject.es-1f59c1d0.js';
import '../../createSvgIcon-141865d4.js';
import '../../Grid-f6c53e5a.js';
import '../../extendSxProp-f37d7304.js';
import '../../requirePropFactory-762b28b9.js';
import '../../Popover-16e53fc0.js';
import '../../ownerDocument-08286491.js';
import '../../isHostComponent-7b82e20e.js';
import '../../ownerWindow-511cbe55.js';
import '../../Grow-144e5c05.js';
import 'react-dom';
import '../../exactProp-2b7ae831.js';
import '../../refType-2daf2908.js';
import '../../inheritsLoose-8d9312ec.js';
import '../../setPrototypeOf-38804714.js';
import '../../TransitionGroupContext-99ee4842.js';
import '../../elementTypeAcceptingRef-58d95132.js';
import '../../Button-05f9d041.js';
import '../../ButtonBase-fe35ba23.js';
import '../../emotion-react.esm-10db94ea.js';
import '../../hoist-non-react-statics.cjs-887936b4.js';
import '../../assertThisInitialized-d8516fd7.js';
import '../../useIsFocusVisible-7eb97459.js';
import '../../makeStyles-3f0becbd.js';
import '../../tiny-warning.esm-9caf1e37.js';
import '../../toConsumableArray-14d095fd.js';
import '../../_commonjsHelpers-41cdd1e7.js';
import '../../createSvgIcon-08f23b3f.js';
import '../../useId-9539b538.js';
import '../../unsupportedProp-90079dce.js';
import '../../FormHelperText-9aa7662f.js';
import '../../utils-a2178b2f.js';
import '../../FormControlContext-3e99c910.js';
import '../../useFormControl-5a78d430.js';
import '../../InputLabel-dec1cb11.js';
import '../../Input-505624cb.js';
import '../../InputBase-ac030ecb.js';

function calculateRangeChange({
  utils,
  range,
  newDate: selectedDate,
  currentlySelectingRangeEnd
}) {
  const [start, end] = range;

  if (currentlySelectingRangeEnd === 'start') {
    return Boolean(end) && utils.isAfter(selectedDate, end) ? {
      nextSelection: 'end',
      newRange: [selectedDate, null]
    } : {
      nextSelection: 'end',
      newRange: [selectedDate, end]
    };
  }

  return Boolean(start) && utils.isBefore(selectedDate, start) ? {
    nextSelection: 'end',
    newRange: [selectedDate, null]
  } : {
    nextSelection: 'start',
    newRange: [start, selectedDate]
  };
}
function calculateRangePreview(options) {
  if (!options.newDate) {
    return [null, null];
  }

  const [start, end] = options.range;
  const {
    newRange
  } = calculateRangeChange(options);

  if (!start || !end) {
    return newRange;
  }

  const [previewStart, previewEnd] = newRange;
  return options.currentlySelectingRangeEnd === 'end' ? [end, previewEnd] : [previewStart, start];
}

const styles$3 = {
  root: {},
  penIcon: {
    position: 'relative',
    top: 4
  },
  dateTextContainer: {
    display: 'flex'
  }
};

var _ref = /*#__PURE__*/createElement(Typography, {
  variant: "h5"
}, "\xA0", '–', "\xA0");

/**
 * @ignore - internal component.
 */
const DateRangePickerToolbar = ({
  classes,
  currentlySelectingRangeEnd,
  date: [start, end],
  endText,
  isMobileKeyboardViewOpen,
  setCurrentlySelectingRangeEnd,
  startText,
  toggleMobileKeyboardView,
  toolbarFormat,
  toolbarTitle = 'SELECT DATE RANGE'
}) => {
  const utils = useUtils();
  const startDateValue = start ? utils.formatByString(start, toolbarFormat || utils.formats.shortDate) : startText;
  const endDateValue = end ? utils.formatByString(end, toolbarFormat || utils.formats.shortDate) : endText;
  return /*#__PURE__*/createElement(PickersToolbar, {
    className: classes.root,
    toolbarTitle: toolbarTitle,
    isMobileKeyboardViewOpen: isMobileKeyboardViewOpen,
    toggleMobileKeyboardView: toggleMobileKeyboardView,
    isLandscape: false,
    penIconClassName: classes.penIcon
  }, /*#__PURE__*/createElement("div", {
    className: classes.dateTextContainer
  }, /*#__PURE__*/createElement(PickersToolbarButton, {
    variant: start !== null ? 'h5' : 'h6',
    value: startDateValue,
    selected: currentlySelectingRangeEnd === 'start',
    onClick: () => setCurrentlySelectingRangeEnd('start')
  }), _ref, /*#__PURE__*/createElement(PickersToolbarButton, {
    variant: end !== null ? 'h5' : 'h6',
    value: endDateValue,
    selected: currentlySelectingRangeEnd === 'end',
    onClick: () => setCurrentlySelectingRangeEnd('end')
  })));
};

var DateRangePickerToolbar$1 = withStyles(styles$3, {
  name: 'MuiDateRangePickerToolbar'
})(DateRangePickerToolbar);

const endBorderStyle = {
  borderTopRightRadius: '50%',
  borderBottomRightRadius: '50%'
};
const startBorderStyle = {
  borderTopLeftRadius: '50%',
  borderBottomLeftRadius: '50%'
};

const styles$2 = theme => ({
  root: {
    '&:first-child $rangeIntervalDayPreview': _extends({}, startBorderStyle, {
      borderLeftColor: theme.palette.divider
    }),
    '&:last-child $rangeIntervalDayPreview': _extends({}, endBorderStyle, {
      borderRightColor: theme.palette.divider
    })
  },
  rangeIntervalDayHighlight: {
    borderRadius: 0,
    color: theme.palette.primary.contrastText,
    backgroundColor: alpha(theme.palette.primary.light, 0.6),
    '&:first-child': startBorderStyle,
    '&:last-child': endBorderStyle
  },
  rangeIntervalDayHighlightStart: _extends({}, startBorderStyle, {
    paddingLeft: 0,
    marginLeft: DAY_MARGIN / 2
  }),
  rangeIntervalDayHighlightEnd: _extends({}, endBorderStyle, {
    paddingRight: 0,
    marginRight: DAY_MARGIN / 2
  }),
  day: {
    // Required to overlap preview border
    transform: 'scale(1.1)',
    '& > *': {
      transform: 'scale(0.9)'
    }
  },
  dayOutsideRangeInterval: {
    '&:hover': {
      border: `1px solid ${theme.palette.grey[500]}`
    }
  },
  dayInsideRangeInterval: {
    color: theme.palette.getContrastText(alpha(theme.palette.primary.light, 0.6))
  },
  notSelectedDate: {
    backgroundColor: 'transparent'
  },
  rangeIntervalPreview: {
    // replace default day component margin with transparent border to avoid jumping on preview
    border: '2px solid transparent'
  },
  rangeIntervalDayPreview: {
    borderRadius: 0,
    border: `2px dashed ${theme.palette.divider}`,
    borderLeftColor: 'transparent',
    borderRightColor: 'transparent',
    '&$rangeIntervalDayPreviewStart': _extends({
      borderLeftColor: theme.palette.divider
    }, startBorderStyle),
    '&$rangeIntervalDayPreviewEnd': _extends({
      borderRightColor: theme.palette.divider
    }, endBorderStyle)
  },
  rangeIntervalDayPreviewStart: {},
  rangeIntervalDayPreviewEnd: {}
});

const DateRangePickerDay = /*#__PURE__*/forwardRef(function DateRangePickerDay(props, ref) {
  const {
    classes,
    className,
    day,
    outsideCurrentMonth,
    isEndOfHighlighting,
    isEndOfPreviewing,
    isHighlighting,
    isPreviewing,
    isStartOfHighlighting,
    isStartOfPreviewing,
    selected = false
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["classes", "className", "day", "outsideCurrentMonth", "isEndOfHighlighting", "isEndOfPreviewing", "isHighlighting", "isPreviewing", "isStartOfHighlighting", "isStartOfPreviewing", "selected"]);

  const utils = useUtils();
  const isEndOfMonth = utils.isSameDay(day, utils.endOfMonth(day));
  const isStartOfMonth = utils.isSameDay(day, utils.startOfMonth(day));
  const shouldRenderHighlight = isHighlighting && !outsideCurrentMonth;
  const shouldRenderPreview = isPreviewing && !outsideCurrentMonth;
  return /*#__PURE__*/createElement("div", {
    className: clsx(classes.root, className, (isEndOfHighlighting || isEndOfMonth) && classes.rangeIntervalDayHighlightEnd, (isStartOfHighlighting || isStartOfMonth) && classes.rangeIntervalDayHighlightStart, shouldRenderHighlight && classes.rangeIntervalDayHighlight)
  }, /*#__PURE__*/createElement("div", {
    role: "cell",
    className: clsx(classes.rangeIntervalPreview, (isEndOfPreviewing || isEndOfMonth) && classes.rangeIntervalDayPreviewEnd, (isStartOfPreviewing || isStartOfMonth) && classes.rangeIntervalDayPreviewStart, shouldRenderPreview && classes.rangeIntervalDayPreview)
  }, /*#__PURE__*/createElement(PickersDay, _extends({}, other, {
    ref: ref,
    disableMargin: true,
    allowSameDateSelection: true,
    allowKeyboardControl: false,
    day: day,
    selected: selected,
    outsideCurrentMonth: outsideCurrentMonth,
    className: clsx(classes.day, !selected && [classes.notSelectedDate, isHighlighting && classes.dayInsideRangeInterval], !isHighlighting && classes.dayOutsideRangeInterval)
  }))));
});
process.env.NODE_ENV !== "production" ? DateRangePickerDay.propTypes = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit TypeScript types and run "yarn proptypes"  |
  // ----------------------------------------------------------------------

  /**
   * The content of the component.
   */
  children: propTypes.node,

  /**
   * @ignore
   */
  classes: propTypes.object.isRequired,

  /**
   * @ignore
   */
  className: propTypes.string,

  /**
   * The date to show.
   */
  day: propTypes.any.isRequired,

  /**
   * Set to `true` if the `day` is the end of a highlighted date range.
   */
  isEndOfHighlighting: propTypes.bool.isRequired,

  /**
   * Set to `true` if the `day` is the start of a highlighted date range.
   */
  isEndOfPreviewing: propTypes.bool.isRequired,

  /**
   * Set to `true` if the `day` is in a highlighted date range.
   */
  isHighlighting: propTypes.bool.isRequired,

  /**
   * Set to `true` if the `day` is in a preview date range.
   */
  isPreviewing: propTypes.bool.isRequired,

  /**
   * Set to `true` if the `day` is the start of a highlighted date range.
   */
  isStartOfHighlighting: propTypes.bool.isRequired,

  /**
   * Set to `true` if the `day` is the end of a highlighted date range.
   */
  isStartOfPreviewing: propTypes.bool.isRequired,

  /**
   * If `true`, day is outside of month and will be hidden.
   */
  outsideCurrentMonth: propTypes.bool.isRequired,

  /**
   * If `true`, renders as selected.
   * @default false
   */
  selected: propTypes.bool
} : void 0;
/**
 *
 * API:
 *
 * - [DateRangePickerDay API](https://material-ui.com/api/date-range-picker-day/)
 */

var DateRangePickerDay$1 = withStyles(styles$2, {
  name: 'MuiDateRangePickerDay'
})( /*#__PURE__*/memo(DateRangePickerDay, (prevProps, nextProps) => {
  return prevProps.isHighlighting === nextProps.isHighlighting && prevProps.isEndOfHighlighting === nextProps.isEndOfHighlighting && prevProps.isStartOfHighlighting === nextProps.isStartOfHighlighting && prevProps.isPreviewing === nextProps.isPreviewing && prevProps.isEndOfPreviewing === nextProps.isEndOfPreviewing && prevProps.isStartOfPreviewing === nextProps.isStartOfPreviewing && areDayPropsEqual(prevProps, nextProps);
}));

const onlyDateView = ['date'];
/**
 * @ignore - internal component.
 */

function DateRangePickerViewMobile(props) {
  const {
    changeMonth,
    components,
    componentsProps,
    date,
    leftArrowButtonText,
    maxDate: maxDateProp,
    minDate: minDateProp,
    onChange,
    renderDay = (_, dayProps) => /*#__PURE__*/createElement(DateRangePickerDay$1, dayProps),
    rightArrowButtonText
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["changeMonth", "components", "componentsProps", "date", "leftArrowButtonText", "maxDate", "minDate", "onChange", "renderDay", "rightArrowButtonText"]);

  const utils = useUtils();
  const minDate = minDateProp || utils.date(defaultMinDate);
  const maxDate = maxDateProp || utils.date(defaultMaxDate);
  return /*#__PURE__*/createElement(Fragment, null, /*#__PURE__*/createElement(PickersCalendarHeader, _extends({
    components: components,
    componentsProps: componentsProps,
    leftArrowButtonText: leftArrowButtonText,
    maxDate: maxDate,
    minDate: minDate,
    onMonthChange: changeMonth,
    openView: "date",
    rightArrowButtonText: rightArrowButtonText,
    views: onlyDateView
  }, other)), /*#__PURE__*/createElement(PickersCalendar, _extends({}, other, {
    date: date,
    onChange: onChange,
    onFocusedDayChange: doNothing,
    renderDay: (day, _, DayProps) => renderDay(day, _extends({
      isPreviewing: false,
      isStartOfPreviewing: false,
      isEndOfPreviewing: false,
      isHighlighting: isWithinRange(utils, day, date),
      isStartOfHighlighting: isStartOfRange(utils, day, date),
      isEndOfHighlighting: isEndOfRange(utils, day, date)
    }, DayProps))
  })));
}

const styles$1 = theme => ({
  root: {
    display: 'flex',
    alignItems: 'baseline',
    [theme.breakpoints.down('xs')]: {
      flexDirection: 'column',
      alignItems: 'center'
    }
  },
  toLabelDelimiter: {
    margin: '8px 0',
    [theme.breakpoints.up('sm')]: {
      margin: '0 16px'
    }
  }
});

/**
 * @ignore - internal component.
 */
const DateRangePickerInput = (_ref) => {
  let {
    classes,
    containerRef,
    currentlySelectingRangeEnd,
    disableOpenPicker,
    endText,
    forwardedRef,
    onBlur,
    onChange,
    open,
    openPicker,
    rawValue: [start, end],
    readOnly,
    renderInput,
    setCurrentlySelectingRangeEnd,
    startText,
    TextFieldProps,
    validationError: [startValidationError, endValidationError]
  } = _ref,
      other = _objectWithoutPropertiesLoose(_ref, ["classes", "containerRef", "currentlySelectingRangeEnd", "disableOpenPicker", "endText", "forwardedRef", "onBlur", "onChange", "open", "openPicker", "rawValue", "rawValue", "readOnly", "renderInput", "setCurrentlySelectingRangeEnd", "startText", "TextFieldProps", "validationError"]);

  const utils = useUtils();
  const startRef = useRef(null);
  const endRef = useRef(null);
  const wrapperVariant = useContext(WrapperVariantContext);
  useEffect(() => {
    if (!open) {
      return;
    }

    if (currentlySelectingRangeEnd === 'start') {
      var _startRef$current;

      (_startRef$current = startRef.current) === null || _startRef$current === void 0 ? void 0 : _startRef$current.focus();
    } else if (currentlySelectingRangeEnd === 'end') {
      var _endRef$current;

      (_endRef$current = endRef.current) === null || _endRef$current === void 0 ? void 0 : _endRef$current.focus();
    }
  }, [currentlySelectingRangeEnd, open]); // TODO: rethink this approach. We do not need to wait for calendar to be updated to rerender input (looks like freezing)
  // TODO: so simply break 1 react's commit phase in 2 (first for input and second for calendars) by executing onChange in the next tick

  const lazyHandleChangeCallback = useCallback((...args) => executeInTheNextEventLoopTick(() => onChange(...args)), [onChange]);

  const handleStartChange = (date, inputString) => {
    lazyHandleChangeCallback([date, utils.date(end)], inputString);
  };

  const handleEndChange = (date, inputString) => {
    lazyHandleChangeCallback([utils.date(start), date], inputString);
  };

  const openRangeStartSelection = () => {
    if (setCurrentlySelectingRangeEnd) {
      setCurrentlySelectingRangeEnd('start');
    }

    if (!disableOpenPicker) {
      openPicker();
    }
  };

  const openRangeEndSelection = () => {
    if (setCurrentlySelectingRangeEnd) {
      setCurrentlySelectingRangeEnd('end');
    }

    if (!disableOpenPicker) {
      openPicker();
    }
  };

  const openOnFocus = wrapperVariant === 'desktop';
  const startInputProps = useMaskedInput(_extends({}, other, {
    readOnly,
    rawValue: start,
    onChange: handleStartChange,
    label: startText,
    validationError: startValidationError !== null,
    TextFieldProps: _extends({}, TextFieldProps, {
      ref: startRef,
      focused: open && currentlySelectingRangeEnd === 'start'
    }),
    inputProps: {
      onClick: !openOnFocus ? openRangeStartSelection : undefined,
      onFocus: openOnFocus ? openRangeStartSelection : undefined
    }
  }));
  const endInputProps = useMaskedInput(_extends({}, other, {
    readOnly,
    label: endText,
    rawValue: end,
    onChange: handleEndChange,
    validationError: endValidationError !== null,
    TextFieldProps: _extends({}, TextFieldProps, {
      ref: endRef,
      focused: open && currentlySelectingRangeEnd === 'end'
    }),
    inputProps: {
      onClick: !openOnFocus ? openRangeEndSelection : undefined,
      onFocus: openOnFocus ? openRangeEndSelection : undefined
    }
  }));
  return /*#__PURE__*/createElement("div", {
    onBlur: onBlur,
    className: classes.root,
    ref: mergeRefs([containerRef, forwardedRef])
  }, renderInput(startInputProps, endInputProps));
};

var DateRangePickerInput$1 = withStyles(styles$1, {
  name: 'MuiDateRangePickerInput'
})(DateRangePickerInput);

const styles = theme => ({
  root: {
    display: 'flex',
    flexDirection: 'row'
  },
  rangeCalendarContainer: {
    '&:not(:last-child)': {
      borderRight: `2px solid ${theme.palette.divider}`
    }
  },
  calendar: {
    minWidth: 312,
    minHeight: 288
  },
  arrowSwitcher: {
    padding: '16px 16px 8px 16px',
    display: 'flex',
    alignItems: 'center',
    justifyContent: 'space-between'
  }
});

function getCalendarsArray(calendars) {
  switch (calendars) {
    case 1:
      return [0];

    case 2:
      return [0, 0];

    case 3:
      return [0, 0, 0];
    // this will not work in IE11, but allows to support any amount of calendars

    default:
      return new Array(calendars).fill(0);
  }
}
/**
 * @ignore - internal component.
 */


function DateRangePickerViewDesktop(props) {
  const {
    calendars = 2,
    changeMonth,
    classes,
    components,
    componentsProps,
    currentlySelectingRangeEnd,
    currentMonth,
    date,
    disableFuture,
    disablePast,
    leftArrowButtonText = 'Previous month',
    maxDate: maxDateProp,
    minDate: minDateProp,
    onChange,
    renderDay = (_, dateRangeProps) => /*#__PURE__*/createElement(DateRangePickerDay$1, dateRangeProps),
    rightArrowButtonText = 'Next month'
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["calendars", "changeMonth", "classes", "components", "componentsProps", "currentlySelectingRangeEnd", "currentMonth", "date", "disableFuture", "disablePast", "leftArrowButtonText", "maxDate", "minDate", "onChange", "renderDay", "rightArrowButtonText"]);

  const utils = useUtils();
  const minDate = minDateProp || utils.date(defaultMinDate);
  const maxDate = maxDateProp || utils.date(defaultMaxDate);
  const [rangePreviewDay, setRangePreviewDay] = useState(null);
  const isNextMonthDisabled = useNextMonthDisabled(currentMonth, {
    disableFuture,
    maxDate
  });
  const isPreviousMonthDisabled = usePreviousMonthDisabled(currentMonth, {
    disablePast,
    minDate
  });
  const previewingRange = calculateRangePreview({
    utils,
    range: date,
    newDate: rangePreviewDay,
    currentlySelectingRangeEnd
  });
  const handleDayChange = useCallback(day => {
    setRangePreviewDay(null);
    onChange(day);
  }, [onChange]);

  const handlePreviewDayChange = newPreviewRequest => {
    if (!isWithinRange(utils, newPreviewRequest, date)) {
      setRangePreviewDay(newPreviewRequest);
    } else {
      setRangePreviewDay(null);
    }
  };

  const CalendarTransitionProps = useMemo(() => ({
    onMouseLeave: () => setRangePreviewDay(null)
  }), []);
  const selectNextMonth = useCallback(() => {
    changeMonth(utils.getNextMonth(currentMonth));
  }, [changeMonth, currentMonth, utils]);
  const selectPreviousMonth = useCallback(() => {
    changeMonth(utils.getPreviousMonth(currentMonth));
  }, [changeMonth, currentMonth, utils]);
  return /*#__PURE__*/createElement("div", {
    className: classes.root
  }, getCalendarsArray(calendars).map((_, index) => {
    const monthOnIteration = utils.setMonth(currentMonth, utils.getMonth(currentMonth) + index);
    return /*#__PURE__*/createElement("div", {
      key: index,
      className: classes.rangeCalendarContainer
    }, /*#__PURE__*/createElement(PickersArrowSwitcher, {
      className: classes.arrowSwitcher,
      onLeftClick: selectPreviousMonth,
      onRightClick: selectNextMonth,
      isLeftHidden: index !== 0,
      isRightHidden: index !== calendars - 1,
      isLeftDisabled: isPreviousMonthDisabled,
      isRightDisabled: isNextMonthDisabled,
      leftArrowButtonText: leftArrowButtonText,
      components: components,
      componentsProps: componentsProps,
      rightArrowButtonText: rightArrowButtonText
    }, utils.format(monthOnIteration, 'monthAndYear')), /*#__PURE__*/createElement(PickersCalendar, _extends({}, other, {
      key: index,
      date: date,
      onFocusedDayChange: doNothing,
      className: classes.calendar,
      onChange: handleDayChange,
      currentMonth: monthOnIteration,
      TransitionProps: CalendarTransitionProps,
      renderDay: (day, __, DayProps) => renderDay(day, _extends({
        isPreviewing: isWithinRange(utils, day, previewingRange),
        isStartOfPreviewing: isStartOfRange(utils, day, previewingRange),
        isEndOfPreviewing: isEndOfRange(utils, day, previewingRange),
        isHighlighting: isWithinRange(utils, day, date),
        isStartOfHighlighting: isStartOfRange(utils, day, date),
        isEndOfHighlighting: isEndOfRange(utils, day, date),
        onMouseEnter: () => handlePreviewDayChange(day)
      }, DayProps))
    })));
  }));
}

var DateRangePickerViewDesktop$1 = withStyles(styles, {
  name: 'MuiDateRangePickerViewDesktop'
})(DateRangePickerViewDesktop);

/**
 * @ignore - internal component.
 */
function DateRangePickerView(props) {
  const {
    calendars = 2,
    className,
    currentlySelectingRangeEnd,
    date,
    DateInputProps,
    defaultCalendarMonth,
    disableAutoMonthSwitching = false,
    disableFuture,
    disableHighlightToday,
    disablePast,
    endText,
    isMobileKeyboardViewOpen,
    maxDate,
    minDate,
    onDateChange,
    onMonthChange,
    open,
    reduceAnimations = defaultReduceAnimations,
    setCurrentlySelectingRangeEnd,
    shouldDisableDate,
    showToolbar,
    startText,
    toggleMobileKeyboardView,
    toolbarFormat,
    toolbarTitle
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["calendars", "className", "currentlySelectingRangeEnd", "date", "DateInputProps", "defaultCalendarMonth", "disableAutoMonthSwitching", "disableFuture", "disableHighlightToday", "disablePast", "endText", "isMobileKeyboardViewOpen", "maxDate", "minDate", "onDateChange", "onMonthChange", "open", "reduceAnimations", "setCurrentlySelectingRangeEnd", "shouldDisableDate", "showToolbar", "startText", "toggleMobileKeyboardView", "toolbarFormat", "toolbarTitle"]);

  const utils = useUtils();
  const wrapperVariant = useContext(WrapperVariantContext);
  const [start, end] = date;
  const {
    changeMonth,
    calendarState,
    isDateDisabled,
    onMonthSwitchingAnimationEnd,
    changeFocusedDay
  } = useCalendarState({
    date: start || end,
    defaultCalendarMonth,
    disableFuture,
    disablePast,
    disableSwitchToMonthOnDayFocus: true,
    maxDate,
    minDate,
    onMonthChange,
    reduceAnimations,
    shouldDisableDate
  });
  const toShowToolbar = showToolbar !== null && showToolbar !== void 0 ? showToolbar : wrapperVariant !== 'desktop';

  const scrollToDayIfNeeded = day => {
    if (!day || !utils.isValid(day) || isDateDisabled(day)) {
      return;
    }

    const currentlySelectedDate = currentlySelectingRangeEnd === 'start' ? start : end;

    if (currentlySelectedDate === null) {
      // do not scroll if one of ages is not selected
      return;
    }

    const displayingMonthRange = wrapperVariant === 'mobile' ? 0 : calendars - 1;
    const currentMonthNumber = utils.getMonth(calendarState.currentMonth);
    const requestedMonthNumber = utils.getMonth(day);

    if (!utils.isSameYear(calendarState.currentMonth, day) || requestedMonthNumber < currentMonthNumber || requestedMonthNumber > currentMonthNumber + displayingMonthRange) {
      const newMonth = currentlySelectingRangeEnd === 'start' ? currentlySelectedDate : // If need to focus end, scroll to the state when "end" is displaying in the last calendar
      utils.addMonths(currentlySelectedDate, -displayingMonthRange);
      changeMonth(newMonth);
    }
  };

  useEffect(() => {
    if (disableAutoMonthSwitching || !open) {
      return;
    }

    scrollToDayIfNeeded(currentlySelectingRangeEnd === 'start' ? start : end);
  }, [currentlySelectingRangeEnd, date]); // eslint-disable-line

  const handleChange = useCallback(newDate => {
    const {
      nextSelection,
      newRange
    } = calculateRangeChange({
      newDate,
      utils,
      range: date,
      currentlySelectingRangeEnd
    });
    setCurrentlySelectingRangeEnd(nextSelection);
    const isFullRangeSelected = currentlySelectingRangeEnd === 'end' && isRangeValid(utils, newRange);
    onDateChange(newRange, wrapperVariant, isFullRangeSelected ? 'finish' : 'partial');
  }, [currentlySelectingRangeEnd, date, onDateChange, setCurrentlySelectingRangeEnd, utils, wrapperVariant]);

  const renderView = () => {
    const sharedCalendarProps = _extends({
      date,
      isDateDisabled,
      changeFocusedDay,
      onChange: handleChange,
      reduceAnimations,
      disableHighlightToday,
      onMonthSwitchingAnimationEnd,
      changeMonth,
      currentlySelectingRangeEnd,
      disableFuture,
      disablePast,
      minDate,
      maxDate
    }, calendarState, other);

    switch (wrapperVariant) {
      case 'desktop':
        {
          return /*#__PURE__*/createElement(DateRangePickerViewDesktop$1, _extends({
            calendars: calendars
          }, sharedCalendarProps));
        }

      default:
        {
          return /*#__PURE__*/createElement(DateRangePickerViewMobile, sharedCalendarProps);
        }
    }
  };

  return /*#__PURE__*/createElement("div", {
    className: className
  }, toShowToolbar && /*#__PURE__*/createElement(DateRangePickerToolbar$1, {
    date: date,
    isMobileKeyboardViewOpen: isMobileKeyboardViewOpen,
    toggleMobileKeyboardView: toggleMobileKeyboardView,
    currentlySelectingRangeEnd: currentlySelectingRangeEnd,
    setCurrentlySelectingRangeEnd: setCurrentlySelectingRangeEnd,
    startText: startText,
    endText: endText,
    toolbarTitle: toolbarTitle,
    toolbarFormat: toolbarFormat
  }), isMobileKeyboardViewOpen ? /*#__PURE__*/createElement(MobileKeyboardInputView, null, /*#__PURE__*/createElement(DateRangePickerInput$1, _extends({
    disableOpenPicker: true,
    ignoreInvalidInputs: true
  }, DateInputProps))) : renderView());
}
process.env.NODE_ENV !== "production" ? DateRangePickerView.propTypes = {
  calendars: propTypes.oneOf([1, 2, 3]),
  disableAutoMonthSwitching: propTypes.bool
} : void 0;

const useDateRangeValidation = makeValidationHook(validateDateRange, {
  isSameError: (a, b) => b !== null && a[1] === b[1] && a[0] === b[0]
});
function makeDateRangePicker(name, Wrapper) {
  const WrapperComponent = makeWrapperComponent(Wrapper, {
    KeyboardDateInputComponent: DateRangePickerInput$1,
    PureDateInputComponent: DateRangePickerInput$1
  });
  const rangePickerValueManager = {
    emptyValue: [null, null],
    parseInput: parseRangeInputValue,
    areValuesEqual: (utils, a, b) => utils.isEqual(a[0], b[0]) && utils.isEqual(a[1], b[1])
  };

  function RangePickerWithStateAndWrapper(inProps) {
    const props = useThemeProps({
      props: inProps,
      name
    });

    const {
      calendars,
      value,
      onChange,
      mask = '__/__/____',
      startText = 'Start',
      endText = 'End',
      inputFormat: passedInputFormat,
      minDate: minDateProp = defaultMinDate,
      maxDate: maxDateProp = defaultMaxDate
    } = props,
          other = _objectWithoutPropertiesLoose(props, ["calendars", "value", "onChange", "mask", "startText", "endText", "inputFormat", "minDate", "maxDate"]);

    const utils = useUtils();
    const minDate = useParsedDate(minDateProp);
    const maxDate = useParsedDate(maxDateProp);
    const [currentlySelectingRangeEnd, setCurrentlySelectingRangeEnd] = useState('start');

    const pickerStateProps = _extends({}, other, {
      value,
      onChange,
      inputFormat: passedInputFormat || utils.formats.keyboardDate
    });

    const restProps = _extends({}, other, {
      minDate,
      maxDate
    });

    const {
      pickerProps,
      inputProps,
      wrapperProps
    } = usePickerState(pickerStateProps, rangePickerValueManager);
    const validationError = useDateRangeValidation(value, restProps);

    const DateInputProps = _extends({}, inputProps, restProps, {
      currentlySelectingRangeEnd,
      setCurrentlySelectingRangeEnd,
      startText,
      endText,
      mask,
      validationError
    });

    return /*#__PURE__*/createElement(WrapperComponent, _extends({
      wrapperProps: wrapperProps,
      DateInputProps: DateInputProps
    }, restProps), /*#__PURE__*/createElement(DateRangePickerView, _extends({
      open: wrapperProps.open,
      DateInputProps: DateInputProps,
      calendars: calendars,
      currentlySelectingRangeEnd: currentlySelectingRangeEnd,
      setCurrentlySelectingRangeEnd: setCurrentlySelectingRangeEnd,
      startText: startText,
      endText: endText
    }, pickerProps, restProps)));
  } // @ts-expect-error Impossible to save component generics when wrapping with HOC


  return /*#__PURE__*/forwardRef((props, ref) => /*#__PURE__*/createElement(RangePickerWithStateAndWrapper, _extends({}, props, {
    forwardedRef: ref
  })));
}

/**
 *
 * Demos:
 *
 * - [Date Range Picker](https://material-ui.com/components/date-range-picker/)
 *
 * API:
 *
 * - [MobileDateRangePicker API](https://material-ui.com/api/mobile-date-range-picker/)
 */
// @typescript-to-proptypes-generate

const MobileDateRangePicker = makeDateRangePicker('MuiMobileDateRangePicker', MobileWrapper);

if (process.env.NODE_ENV !== 'production') {
  MobileDateRangePicker.displayName = 'MobileDateRangePicker';
}

MobileDateRangePicker.propTypes = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit TypeScript types and run "yarn proptypes"  |
  // ----------------------------------------------------------------------

  /**
   * Regular expression to detect "accepted" symbols.
   * @default /\dap/gi
   */
  acceptRegex: propTypes.instanceOf(RegExp),

  /**
   * Enables keyboard listener for moving between days in calendar.
   * Defaults to `true` unless the `ClockPicker` is used inside a `Static*` picker component.
   */
  allowKeyboardControl: propTypes.bool,

  /**
   * If `true`, `onChange` is fired on click even if the same date is selected.
   * @default false
   */
  allowSameDateSelection: propTypes.bool,

  /**
   * The number of calendars that render on **desktop**.
   * @default 2
   */
  calendars: propTypes.oneOf([1, 2, 3]),

  /**
   * Cancel text message.
   * @default "CANCEL"
   */
  cancelText: propTypes.node,

  /**
   * @ignore
   */
  children: propTypes.node,

  /**
   * className applied to the root component.
   */
  className: propTypes.string,

  /**
   * If `true`, it shows the clear action in the picker dialog.
   * @default false
   */
  clearable: propTypes.bool,

  /**
   * Clear text message.
   * @default "CLEAR"
   */
  clearText: propTypes.node,

  /**
   * The components used for each slot.
   * Either a string to use a HTML element or a component.
   * @default {}
   */
  components: propTypes.shape({
    LeftArrowButton: propTypes.elementType,
    LeftArrowIcon: propTypes.elementType,
    RightArrowButton: propTypes.elementType,
    RightArrowIcon: propTypes.elementType,
    SwitchViewButton: propTypes.elementType,
    SwitchViewIcon: propTypes.elementType
  }),

  /**
   * The props used for each slot inside.
   * @default {}
   */
  componentsProps: propTypes.object,

  /**
   * Default calendar month displayed when `value={null}`.
   */
  defaultCalendarMonth: propTypes.any,

  /**
   * Props applied to the [`Dialog`](/api/dialog/) element.
   */
  DialogProps: propTypes.object,

  /**
   * If `true`, after selecting `start` date calendar will not automatically switch to the month of `end` date.
   * @default false
   */
  disableAutoMonthSwitching: propTypes.bool,

  /**
   * If `true` the popup or dialog will immediately close after submitting full date.
   * @default `true` for Desktop, `false` for Mobile (based on the chosen wrapper and `desktopModeMediaQuery` prop).
   */
  disableCloseOnSelect: propTypes.bool,

  /**
   * If `true`, the picker and text field are disabled.
   */
  disabled: propTypes.bool,

  /**
   * @default false
   */
  disableFuture: propTypes.bool,

  /**
   * If `true`, todays date is rendering without highlighting with circle.
   * @default false
   */
  disableHighlightToday: propTypes.bool,

  /**
   * Disable mask on the keyboard, this should be used rarely. Consider passing proper mask for your format.
   * @default false
   */
  disableMaskedInput: propTypes.bool,

  /**
   * Do not render open picker button (renders only text field with validation).
   * @default false
   */
  disableOpenPicker: propTypes.bool,

  /**
   * @default false
   */
  disablePast: propTypes.bool,

  /**
   * Text for end input label and toolbar placeholder.
   * @default "end"
   */
  endText: propTypes.node,

  /**
   * Get aria-label text for control that opens picker dialog. Aria-label text must include selected date. @DateIOType
   * @default (value, utils) => `Choose date, selected date is ${utils.format(utils.date(value), 'fullDate')}`
   */
  getOpenDialogAriaText: propTypes.func,

  /**
   * Get aria-label text for switching between views button.
   */
  getViewSwitchingButtonText: propTypes.func,

  /**
   * @ignore
   */
  ignoreInvalidInputs: propTypes.bool,

  /**
   * Props to pass to keyboard input adornment.
   */
  InputAdornmentProps: propTypes.object,

  /**
   * Format string.
   */
  inputFormat: propTypes.string,

  /**
   * @ignore
   */
  InputProps: propTypes.object,

  /**
   * @ignore
   */
  key: propTypes.oneOfType([propTypes.number, propTypes.string]),

  /**
   * @ignore
   */
  label: propTypes.node,

  /**
   * Left arrow icon aria-label text.
   */
  leftArrowButtonText: propTypes.string,

  /**
   * If `true` renders `LoadingComponent` in calendar instead of calendar view.
   * Can be used to preload information and show it in calendar.
   * @default false
   */
  loading: propTypes.bool,

  /**
   * Custom mask. Can be used to override generate from format. (e.g. `__/__/____ __:__` or `__/__/____ __:__ _M`).
   */
  mask: propTypes.string,

  /**
   * Max selectable date. @DateIOType
   */
  maxDate: propTypes.any,

  /**
   * Min selectable date. @DateIOType
   */
  minDate: propTypes.any,

  /**
   * Ok button text.
   * @default "OK"
   */
  okText: propTypes.node,

  /**
   * Callback fired when date is accepted @DateIOType.
   */
  onAccept: propTypes.func,

  /**
   * Callback fired when the value (the selected date) changes @DateIOType.
   */
  onChange: propTypes.func.isRequired,

  /**
   * Callback fired when the popup requests to be closed.
   * Use in controlled mode (see open).
   */
  onClose: propTypes.func,

  /**
   * Callback that fired when input value or new `value` prop validation returns **new** validation error (or value is valid after error).
   * In case of validation error detected `reason` prop return non-null value and `TextField` must be displayed in `error` state.
   * This can be used to render appropriate form error.
   *
   * [Read the guide](https://next.material-ui-pickers.dev/guides/forms) about form integration and error displaying.
   * @DateIOType
   */
  onError: propTypes.func,

  /**
   * Callback firing on month change. @DateIOType
   */
  onMonthChange: propTypes.func,

  /**
   * Callback fired when the popup requests to be opened.
   * Use in controlled mode (see open).
   */
  onOpen: propTypes.func,

  /**
   * Callback fired on view change.
   */
  onViewChange: propTypes.func,

  /**
   * Control the popup or dialog open state.
   */
  open: propTypes.bool,

  /**
   * Props to pass to keyboard adornment button.
   */
  OpenPickerButtonProps: propTypes.object,

  /**
   * Icon displaying for open picker button.
   */
  openPickerIcon: propTypes.node,

  /**
   * Force rendering in particular orientation.
   */
  orientation: propTypes.oneOf(['landscape', 'portrait']),

  /**
   * Make picker read only.
   */
  readOnly: propTypes.bool,

  /**
   * Disable heavy animations.
   * @default typeof navigator !== 'undefined' && /(android)/i.test(navigator.userAgent)
   */
  reduceAnimations: propTypes.bool,

  /**
   * Custom renderer for `<DateRangePicker />` days. @DateIOType
   * @example (date, DateRangePickerDayProps) => <DateRangePickerDay {...DateRangePickerDayProps} />
   */
  renderDay: propTypes.func,

  /**
   * The `renderInput` prop allows you to customize the rendered input.
   * The `startProps` and `endProps` arguments of this render prop contains props of [TextField](https://material-ui.com/api/text-field/#textfield-api),
   * that you need to forward to the range start/end inputs respectively.
   * Pay specific attention to the `ref` and `inputProps` keys.
   * @example
   * ```jsx
   * <DateRangePicker
   *  renderInput={(startProps, endProps) => (
   *   <React.Fragment>
   *     <TextField {...startProps} />
   *     <Box sx={{ mx: 2 }}> to </Box>
   *     <TextField {...endProps} />
   *   </React.Fragment>;
   *  )}
   * />
   * ````
   */
  renderInput: propTypes.func.isRequired,

  /**
   * Component displaying when passed `loading` true.
   * @default () => <span data-mui-test="loading-progress">...</span>
   */
  renderLoading: propTypes.func,

  /**
   * Custom formatter to be passed into Rifm component.
   */
  rifmFormatter: propTypes.func,

  /**
   * Right arrow icon aria-label text.
   */
  rightArrowButtonText: propTypes.string,

  /**
   * Disable specific date. @DateIOType
   */
  shouldDisableDate: propTypes.func,

  /**
   * Disable specific years dynamically.
   * Works like `shouldDisableDate` but for year selection view @DateIOType.
   */
  shouldDisableYear: propTypes.func,

  /**
   * If `true`, days that have `outsideCurrentMonth={true}` are displayed.
   * @default false
   */
  showDaysOutsideCurrentMonth: propTypes.bool,

  /**
   * If `true`, the today button is displayed. **Note** that `showClearButton` has a higher priority.
   * @default false
   */
  showTodayButton: propTypes.bool,

  /**
   * If `true`, show the toolbar even in desktop mode.
   */
  showToolbar: propTypes.bool,

  /**
   * Text for start input label and toolbar placeholder.
   * @default "Start"
   */
  startText: propTypes.node,

  /**
   * Today text message.
   * @default "TODAY"
   */
  todayText: propTypes.node,

  /**
   * Component that will replace default toolbar renderer.
   */
  ToolbarComponent: propTypes.elementType,

  /**
   * Date format, that is displaying in toolbar.
   */
  toolbarFormat: propTypes.string,

  /**
   * Mobile picker date value placeholder, displaying if `value` === `null`.
   * @default "–"
   */
  toolbarPlaceholder: propTypes.node,

  /**
   * Mobile picker title, displaying in the toolbar.
   * @default "SELECT DATE"
   */
  toolbarTitle: propTypes.node,

  /**
   * The value of the picker.
   */
  value: propTypes.arrayOf(propTypes.oneOfType([propTypes.any, propTypes.instanceOf(Date), propTypes.number, propTypes.string])).isRequired
};

var DatetimePickerFilter = function (props) {
    var filterValue = props.filterValue, setFilter = props.setFilter;
    var value = [
        (filterValue === null || filterValue === void 0 ? void 0 : filterValue.from) || null,
        (filterValue === null || filterValue === void 0 ? void 0 : filterValue.to) || null,
    ];
    function clearInput(key) {
        var _a;
        var remainKey = key === 'from' ? 'to' : 'from';
        var newFilter = filterValue && filterValue[remainKey]
            ? __assign(__assign({}, filterValue), (_a = {}, _a[key] = null, _a)) : undefined;
        setFilter(newFilter);
    }
    return (jsx(MobileDateRangePicker, { startText: props.title + ' from', endText: props.title + ' to', value: value, mask: "__/__/____", inputFormat: "MM/DD/YYYY", onChange: function (_a) {
            var fromDate = _a[0], toDate = _a[1];
            return setFilter({
                from: getDatabaseFormatDate(fromDate || ''),
                to: getDatabaseFormatDate(toDate || ''),
            });
        }, renderInput: function (startProps, endProps) { return (jsxs("div", __assign({ className: "dflex" }, { children: [jsx(TextField, __assign({}, startProps, { variant: "standard", helperText: '', error: false, InputLabelProps: {
                        shrink: true,
                    }, className: styles$4.daterange, InputProps: {
                        endAdornment: (jsx(InputAdornment, __assign({ className: styles$4.adornment, position: "end", onClick: function () {
                                clearInput('from');
                            } }, { children: jsx(IconButton, __assign({ className: styles$4.clearBtn, "aria-label": "toggle password visibility", edge: "end" }, { children: jsx(ClearIcon, { style: { fontSize: '12px' } }, void 0) }), void 0) }), void 0)),
                    } }), void 0),
                jsx("span", __assign({ className: "invisible" }, { children: "::" }), void 0),
                jsx(TextField, __assign({}, endProps, { helperText: '', variant: "standard", error: false, InputLabelProps: { shrink: true }, className: styles$4.daterange, InputProps: {
                        endAdornment: (jsx(InputAdornment, __assign({ className: styles$4.adornment, position: "end", onClick: function () {
                                clearInput('to');
                            } }, { children: jsx(IconButton, __assign({ className: styles$4.clearBtn, "aria-label": "toggle password visibility", edge: "end" }, { children: jsx(ClearIcon, { style: { fontSize: '12px' } }, void 0) }), void 0) }), void 0)),
                    } }), void 0)] }), void 0)); } }, void 0));
};
var DatetimePickerFilter$1 = React.memo(DatetimePickerFilter);

export default DatetimePickerFilter$1;
//# sourceMappingURL=DatetimePickerFilter.js.map
