import { d as __spreadArray, _ as __assign } from '../tslib.es6-a941f97f.js';
import { jsx, jsxs } from 'react/jsx-runtime';
import { useCallback, useEffect, useRef, useState } from 'react';
import { r as reactTable } from '../index-b6c1b619.js';
import { useSticky } from './plugins/useSticky.js';
import { T as TableToolbar, a as Toolbar } from '../TableToolbar-b8f3bd3b.js';
import { s as styles } from '../EnhancedTable.module-3f17e3a7.js';
import { c as clsx } from '../clsx.m-6243b874.js';
import { S as SelectableGroup, R as RowSelectable } from '../RowSelectable-aacb30f4.js';
import ReactTablePagination from './Pagination/ReactTablePagination.js';
import { C as ContextMenu, a as ContextMenuTrigger } from '../connectMenu-7261791b.js';
import '../index-df27ca20.js';
import ConditionalWrap from '../utils/ConditionalWrap.js';
import { c as config } from '../config-2233d325.js';
import { u as useDispatch } from '../index-1c8ec3e4.js';
import { s as selectMultiRows } from '../actions-469e4403.js';
import { g as getStorageInitialState, u as useMainResize, a as useSelector, t as tableSelectableSelector, T as TableContainer } from '../useMainResize-99da2cdb.js';
import { d as debounce_1 } from '../debounce-b9a8de1b.js';
import selectionHook from './plugins/selectionHook.js';
import EditableCellTextField from './EditableCell/EditableCellTextField.js';
import TableHeader from './components/TableHeader.js';
import { S as SELECTION_COLUMN_ID } from '../constants-cdb4cae7.js';
import { useLocalStorageTable } from './plugins/useLocalStorageTable.js';
import { useHiddenColumn } from './plugins/useHiddenColumn.js';
import '../_commonjsHelpers-41cdd1e7.js';
import './Toolbar/ColumnDisplay.js';
import '../createSvgIcon-08f23b3f.js';
import '../createSvgIcon-141865d4.js';
import '../extends-e61fd370.js';
import '../objectWithoutPropertiesLoose-6856ddd5.js';
import '../experimentalStyled-9a0c9477.js';
import '../ownerWindow-511cbe55.js';
import '../ownerDocument-08286491.js';
import '../requirePropFactory-762b28b9.js';
import '../useId-9539b538.js';
import '../unsupportedProp-90079dce.js';
import '../useIsFocusVisible-7eb97459.js';
import '../ArrowDropDown-94d53692.js';
import '../isEqual-738b48ed.js';
import '../_MapCache-a3d3cd04.js';
import '../_isIndex-e6cb62f4.js';
import '../Popover-16e53fc0.js';
import '../withStyles-6a29793a.js';
import '../hoist-non-react-statics.cjs-887936b4.js';
import '../makeStyles-3f0becbd.js';
import '../tiny-warning.esm-9caf1e37.js';
import '../toConsumableArray-14d095fd.js';
import '../inheritsLoose-8d9312ec.js';
import '../setPrototypeOf-38804714.js';
import '../assertThisInitialized-d8516fd7.js';
import '../exactProp-2b7ae831.js';
import '../refType-2daf2908.js';
import '../isHostComponent-7b82e20e.js';
import '../Grow-144e5c05.js';
import 'react-dom';
import '../TransitionGroupContext-99ee4842.js';
import '../elementTypeAcceptingRef-58d95132.js';
import '../FormControlLabel-5b89f3db.js';
import '../useFormControl-5a78d430.js';
import '../FormControlContext-3e99c910.js';
import '../Typography-cbcc1b4d.js';
import '../extendSxProp-f37d7304.js';
import '../Checkbox-31af756d.js';
import '../SwitchBase-1231cda4.js';
import '../IconButton-ccfdb4cc.js';
import '../ButtonBase-fe35ba23.js';
import '../emotion-react.esm-10db94ea.js';
import '../style-inject.es-1f59c1d0.js';
import './Toolbar/FilterBox.js';
import '../Button-05f9d041.js';
import '../GlobalFilter-b4bd8c6f.js';
import '../HighlightOff-fb35c071.js';
import '../lodash-348e7dda.js';
import '../get-fc89bca9.js';
import '../_baseSet-fa34e586.js';
import '../react-router-5a8a5f30.js';
import '../useOnClickOutside-5fbcb3ab.js';
import '../ResizeObserver-da68295b.js';
import '../makeStyles-5b784462.js';
import '../createStyles-8be7b6b1.js';
import '../InputBase-ac030ecb.js';
import '../utils-a2178b2f.js';
import '../Tooltip-73d2407b.js';
import '../Popper-2961f154.js';
import './Toolbar/LocalGlobalFilter.js';
import './Pagination/TablePaginationActions.js';
import '../KeyboardArrowRight-48df2583.js';
import '../TextField/AppTextField.js';
import '../TextField-41fe2395.js';
import '../FormHelperText-9aa7662f.js';
import '../InputLabel-dec1cb11.js';
import '../Input-505624cb.js';
import '../Autocomplete-5b4467ca.js';
import '../MenuItem-16e73a5b.js';
import '../Checkbox/AppCheckBox.js';
import '../EditableCell.module-fb3595c3.js';
import '../Clear-7316bc39.js';
import '../DoneRounded-17c0838b.js';
import '../slicedToArray-9e59c773.js';

var defaultColumn = {
    Cell: EditableCellTextField,
};
var LocalTable = function (props) {
    var _a;
    var columns = props.columns, data = props.data, rightClickMenu = props.rightClickMenu, toolbarItems = props.toolbarItems, localStorageKey = props.localStorageKey, _b = props.useSelection, useSelection = _b === void 0 ? true : _b, _c = props.useBlockingOverlay, useBlockingOverlay = _c === void 0 ? true : _c, _d = props.hasGlobalSearch, hasGlobalSearch = _d === void 0 ? true : _d, overlayConfig = props.overlayConfig, alignItemsCenter = props.alignItemsCenter;
    var initState = getStorageInitialState(localStorageKey);
    var instance = reactTable.useTable.apply(void 0, __spreadArray([{
            columns: columns,
            data: data,
            defaultColumn: defaultColumn,
            initialState: __assign({ pageIndex: 0, pageSize: config.perPage }, initState),
            pageCount: 100,
        }, reactTable.useFlexLayout,
        reactTable.useResizeColumns,
        reactTable.useFilters,
        reactTable.useColumnOrder,
        reactTable.useGlobalFilter,
        reactTable.useSortBy,
        reactTable.usePagination,
        reactTable.useRowSelect,
        useSticky,
        useLocalStorageTable,
        useHiddenColumn], (useSelection ? [selectionHook] : [])));
    var getTableProps = instance.getTableProps, prepareRow = instance.prepareRow, page = instance.page, gotoPage = instance.gotoPage, setPageSize = instance.setPageSize, selectedFlatRows = instance.selectedFlatRows, toggleAllRowsSelected = instance.toggleAllRowsSelected, rows = instance.rows, _e = instance.state, pageIndex = _e.pageIndex, pageSize = _e.pageSize;
    var mainWidth = useMainResize().width;
    var stableColumns = [SELECTION_COLUMN_ID];
    var dispatch = useDispatch();
    var delayedQuery = useCallback(debounce_1(function (rows) {
        dispatch(selectMultiRows(rows));
    }, 500), [dispatch]);
    useEffect(function () {
        var rows = selectedFlatRows.map(function (item) { return item.original; });
        delayedQuery(rows);
    }, [delayedQuery, selectedFlatRows]);
    var tableRef = useRef(null);
    useEffect(function () {
        if (tableRef.current) {
            tableRef.current.scrollIntoView({ behavior: 'smooth' });
        }
    }, [pageIndex, pageSize]);
    var Pagination = (jsx(ReactTablePagination, { gotoPage: gotoPage, pageIndex: pageIndex, setPageSize: setPageSize, pageSize: pageSize, pageTotal: data.length }, void 0));
    var isSelectable = useSelector(tableSelectableSelector);
    var _f = useState(null), previousRow = _f[0], setPreviousRow = _f[1];
    var handleSelectableGroupFinish = function (selectedRows) {
        if (selectedRows && selectedRows.length > 0) {
            selectedRows.forEach(function (row) {
                if (row && row.props) {
                    row.props.row.toggleRowSelected();
                }
            });
        }
    };
    return (jsxs(TableContainer, __assign({ className: clsx(styles.tableContainer, useBlockingOverlay &&
            !(overlayConfig === null || overlayConfig === void 0 ? void 0 : overlayConfig.displayFullscreen) &&
            styles.positionRelative), style: { width: instance.totalVisibleColumnsWidth } }, { children: [jsx(TableToolbar, { width: mainWidth, instance: instance, stableColumns: stableColumns, toolbarItems: toolbarItems, pagination: Pagination, hasGlobalSearch: hasGlobalSearch, isLocal: true }, void 0),
            jsx("div", __assign({ className: styles.actionScroll }, { children: jsxs(SelectableGroup, __assign({ className: styles.fixWidthScroll, disabled: isSelectable, deselectOnEsc: true, selectOnClick: false, enableDeselect: true, allowClickWithoutSelected: false, tolerance: 5, resetOnStart: true, onSelectionFinish: handleSelectableGroupFinish, ignoreList: ['.th'] }, { children: [rightClickMenu && (jsx(ContextMenu, __assign({ id: "same_unique_identifier", className: styles.contextMenu }, { children: rightClickMenu }), void 0)),
                        jsx("div", __assign({ className: clsx(styles.tableBodyScroll, styles.noHighLight) }, { children: jsx(ConditionalWrap, __assign({ condition: !!rightClickMenu, wrap: function (children) { return (jsx(ContextMenuTrigger, __assign({ id: 'same_unique_identifier', holdToDisplay: -1 }, { children: children }), void 0)); } }, { children: jsxs("div", __assign({ ref: tableRef }, getTableProps(), { className: clsx(styles.table, styles.sticky) }, { children: [jsx(TableHeader, { instance: instance, stableColumns: stableColumns }, void 0),
                                        jsx("div", __assign({}, instance.getTableBodyProps(), { style: { width: instance.totalVisibleColumnsWidth }, className: clsx((_a = {},
                                                _a[styles.alignItemsCenter] = data.length && alignItemsCenter,
                                                _a)) }, { children: data.length > 0 ? (page.map(function (row) {
                                                prepareRow(row);
                                                return (jsx(RowSelectable, __assign({}, row.getRowProps(), { row: row, previousRow: previousRow, setPreviousRow: setPreviousRow, toggleAllRowsSelected: toggleAllRowsSelected, rows: rows }), void 0));
                                            })) : (jsx("div", __assign({ className: "p-14" }, { children: "No record found" }), void 0)) }), void 0)] }), void 0) }), void 0) }), void 0)] }), void 0) }), void 0),
            jsxs(Toolbar, __assign({ className: clsx(styles.toolbar), style: { width: mainWidth } }, { children: [selectedFlatRows.length > 0 && (jsxs("span", { children: [selectedFlatRows.length, " Selected Rows"] }, void 0)), Pagination] }), void 0)] }), void 0));
};

export default LocalTable;
//# sourceMappingURL=LocalTable.js.map
