import { _ as __assign, d as __spreadArray } from '../../tslib.es6-a941f97f.js';
import { jsxs, jsx } from 'react/jsx-runtime';
import React from 'react';
import { s as styles } from '../../EnhancedTable.module-3f17e3a7.js';
import { c as clsx } from '../../clsx.m-6243b874.js';
import { g as getDefaultExportFromCjs, c as createCommonjsModule } from '../../_commonjsHelpers-41cdd1e7.js';
import { i as interopRequireWildcard, a as interopRequireDefault, c as createSvgIcon } from '../../createSvgIcon-08f23b3f.js';
import { A as AppDownIcon } from '../../ArrowDropDown-94d53692.js';
import { S as SELECTION_COLUMN_ID } from '../../constants-cdb4cae7.js';
import { l as isEqual_1 } from '../../isEqual-738b48ed.js';
import { a as Popover } from '../../Popover-16e53fc0.js';
import { F as FormControlLabel } from '../../FormControlLabel-5b89f3db.js';
import { C as Checkbox } from '../../Checkbox-31af756d.js';
import '../../style-inject.es-1f59c1d0.js';
import '../../createSvgIcon-141865d4.js';
import '../../extends-e61fd370.js';
import '../../objectWithoutPropertiesLoose-6856ddd5.js';
import '../../index-df27ca20.js';
import '../../experimentalStyled-9a0c9477.js';
import '../../ownerWindow-511cbe55.js';
import '../../ownerDocument-08286491.js';
import '../../requirePropFactory-762b28b9.js';
import '../../useId-9539b538.js';
import '../../unsupportedProp-90079dce.js';
import '../../useIsFocusVisible-7eb97459.js';
import '../../_MapCache-a3d3cd04.js';
import '../../_isIndex-e6cb62f4.js';
import '../../withStyles-6a29793a.js';
import '../../hoist-non-react-statics.cjs-887936b4.js';
import '../../makeStyles-3f0becbd.js';
import '../../tiny-warning.esm-9caf1e37.js';
import '../../toConsumableArray-14d095fd.js';
import '../../inheritsLoose-8d9312ec.js';
import '../../setPrototypeOf-38804714.js';
import '../../assertThisInitialized-d8516fd7.js';
import '../../exactProp-2b7ae831.js';
import '../../refType-2daf2908.js';
import '../../isHostComponent-7b82e20e.js';
import '../../Grow-144e5c05.js';
import 'react-dom';
import '../../TransitionGroupContext-99ee4842.js';
import '../../elementTypeAcceptingRef-58d95132.js';
import '../../useFormControl-5a78d430.js';
import '../../FormControlContext-3e99c910.js';
import '../../Typography-cbcc1b4d.js';
import '../../extendSxProp-f37d7304.js';
import '../../SwitchBase-1231cda4.js';
import '../../IconButton-ccfdb4cc.js';
import '../../ButtonBase-fe35ba23.js';
import '../../emotion-react.esm-10db94ea.js';

var ViewColumn = createCommonjsModule(function (module, exports) {





Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React$1 = interopRequireWildcard(React);

var _createSvgIcon = interopRequireDefault(createSvgIcon);

var _default = (0, _createSvgIcon.default)( /*#__PURE__*/React$1.createElement("path", {
  d: "M10 18h5V5h-5v13zm-6 0h5V5H4v13zM16 5v13h5V5h-5z"
}), 'ViewColumn');

exports.default = _default;
});

var AppColumnsIcon = /*@__PURE__*/getDefaultExportFromCjs(ViewColumn);

var ColumnDisplay = function (props) {
    var stableColumns = props.stableColumns, instance = props.instance, defaultHiddenColumns = props.defaultHiddenColumns;
    var _a = props.instance, allColumns = _a.allColumns, state = _a.state, setColumnOrder = _a.setColumnOrder;
    var columnOrder = state.columnOrder, leftStickyColumns = state.leftStickyColumns;
    var _b = React.useState(null), anchorEl = _b[0], setAnchorEl = _b[1];
    var handleClick = function (event) {
        setAnchorEl(event.currentTarget);
    };
    var handleClose = function () {
        setAnchorEl(null);
    };
    function isDisableColumn(column) {
        return stableColumns.includes(column.id) || !column.Header;
    }
    var isShowAll = instance.visibleColumns.length === allColumns.length;
    function toggleAll(event) {
        if (event.target.checked) {
            instance.setHiddenColumns([]);
        }
        else {
            instance.setHiddenColumns(allColumns
                .map(function (item) { return item.id; })
                .filter(function (index) { return !stableColumns.includes(index); }));
        }
    }
    function priorityLeftStickyReorder() {
        var newColumnOrder = Array.from(new Set(__spreadArray(__spreadArray([SELECTION_COLUMN_ID], columnOrder), leftStickyColumns)));
        newColumnOrder = newColumnOrder.sort(function (a, b) {
            return Number(leftStickyColumns.includes(b)) -
                Number(leftStickyColumns.includes(a));
        });
        if (!isEqual_1(newColumnOrder, columnOrder)) {
            setColumnOrder(newColumnOrder);
        }
    }
    var open = Boolean(anchorEl);
    return (jsxs(React.Fragment, { children: [jsxs("span", __assign({ className: styles.action, onClick: handleClick }, { children: [jsx(AppColumnsIcon, { className: styles.iconColumns }, void 0),
                    jsx("span", { children: "COLUMNS" }, void 0),
                    jsx(AppDownIcon, { className: styles.iconDown }, void 0)] }), void 0),
            jsx(Popover, __assign({ open: open, anchorEl: anchorEl, onClose: handleClose, anchorOrigin: {
                    vertical: 'bottom',
                    horizontal: 'right',
                }, transformOrigin: {
                    vertical: 'top',
                    horizontal: 'left',
                } }, { children: jsxs("div", __assign({ className: styles.popover }, { children: [jsxs("div", { children: [jsx(FormControlLabel, { title: 'Toggle column visibility', control: jsx(Checkbox, { color: "primary", checked: isShowAll, indeterminate: !isShowAll && !instance.allColumnsHidden, onChange: function (event) {
                                            toggleAll(event);
                                            if (event.target.checked) {
                                                priorityLeftStickyReorder();
                                            }
                                        } }, void 0), label: jsx("span", __assign({ className: "primary-text" }, { children: "All" }), void 0) }, void 0),
                                jsx("span", __assign({ className: styles.clearOrderTag, onClick: function () {
                                        instance.setColumnOrder([]);
                                        instance.resetAllStickyColumns();
                                        if (Array.isArray(defaultHiddenColumns) &&
                                            defaultHiddenColumns.length > 0) {
                                            instance.setHiddenColumns(defaultHiddenColumns);
                                        }
                                    }, title: 'Reset the order of table columns' }, { children: "Reset Order" }), void 0)] }, void 0),
                        allColumns
                            .filter(function (column) { return !column.isHidden; })
                            .map(function (column) { return (jsx("div", { children: jsx(FormControlLabel, { className: clsx(isDisableColumn(column) && 'displayNone'), control: jsx(Checkbox, __assign({}, column.getToggleHiddenProps(), { checked: column.isVisible, onChange: function (event) {
                                        column.toggleHidden();
                                        if (event.target.checked) {
                                            priorityLeftStickyReorder();
                                        }
                                    }, color: "primary" }), void 0), label: typeof column.Header === 'string'
                                    ? column.Header
                                    : column.id }, void 0) }, column.id)); }),
                        jsx("br", {}, void 0)] }), void 0) }), void 0)] }, void 0));
};
var ColumnDisplay$1 = React.memo(ColumnDisplay);

export default ColumnDisplay$1;
//# sourceMappingURL=ColumnDisplay.js.map
