import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { jsxs, jsx } from 'react/jsx-runtime';
import { useState, useRef, useCallback } from 'react';
import { S as SearchIcon, H as HighlightOffIcon } from '../../HighlightOff-fb35c071.js';
import { c as clsx } from '../../clsx.m-6243b874.js';
import { l as lodash } from '../../lodash-348e7dda.js';
import { u as useOnClickOutside } from '../../useOnClickOutside-5fbcb3ab.js';
import { T as Tooltip } from '../../Tooltip-73d2407b.js';
import { b as InputBase } from '../../InputBase-ac030ecb.js';
import { I as IconButton } from '../../IconButton-ccfdb4cc.js';
import { m as makeStyles } from '../../makeStyles-5b784462.js';
import { c as createStyles } from '../../createStyles-8be7b6b1.js';
import '../../_commonjsHelpers-41cdd1e7.js';
import '../../createSvgIcon-08f23b3f.js';
import '../../createSvgIcon-141865d4.js';
import '../../extends-e61fd370.js';
import '../../objectWithoutPropertiesLoose-6856ddd5.js';
import '../../index-df27ca20.js';
import '../../experimentalStyled-9a0c9477.js';
import '../../ownerWindow-511cbe55.js';
import '../../ownerDocument-08286491.js';
import '../../requirePropFactory-762b28b9.js';
import '../../useId-9539b538.js';
import '../../unsupportedProp-90079dce.js';
import '../../useIsFocusVisible-7eb97459.js';
import '../../Grow-144e5c05.js';
import 'react-dom';
import '../../exactProp-2b7ae831.js';
import '../../refType-2daf2908.js';
import '../../inheritsLoose-8d9312ec.js';
import '../../setPrototypeOf-38804714.js';
import '../../TransitionGroupContext-99ee4842.js';
import '../../Popper-2961f154.js';
import '../../utils-a2178b2f.js';
import '../../FormControlContext-3e99c910.js';
import '../../emotion-react.esm-10db94ea.js';
import '../../hoist-non-react-statics.cjs-887936b4.js';
import '../../isHostComponent-7b82e20e.js';
import '../../elementTypeAcceptingRef-58d95132.js';
import '../../ButtonBase-fe35ba23.js';
import '../../assertThisInitialized-d8516fd7.js';
import '../../makeStyles-3f0becbd.js';
import '../../tiny-warning.esm-9caf1e37.js';
import '../../toConsumableArray-14d095fd.js';

var useStyles = makeStyles(function (theme) {
    return createStyles({
        root: {
            display: 'inline-flex',
            alignItems: 'center',
            transition: 'width 0.75s cubic-bezier(0.000, 0.795, 0.000, 1.000)',
            padding: '1px 3px',
        },
        open: {
            border: '1px solid #38B4C9',
            borderRadius: '50px',
            '& input': {
                marginLeft: 15,
            },
        },
        input: {
            flex: 1,
            transition: 'all 0.75s cubic-bezier(0.000, 0.795, 0.000, 1.000)',
        },
        iconButton: {
            padding: 10,
            color: '#38B4C9',
            fontSize: '16px',
        },
        hide: {
            width: 0,
            transition: 'all 0.75s cubic-bezier(0.000, 0.795, 0.000, 1.000)',
        },
    });
});
function LocalGlobalFilter(_a) {
    var globalFilter = _a.globalFilter, setGlobalFilter = _a.setGlobalFilter;
    var classes = useStyles();
    var _b = useState(globalFilter || ''), inputValue = _b[0], setInputValue = _b[1];
    var _c = useState(!!inputValue), open = _c[0], setOpen = _c[1];
    var ref = useRef(null);
    var divRef = useRef(null);
    useOnClickOutside(divRef, function () { return close(); });
    var delayedQuery = useCallback(lodash.debounce(function (q) {
        setGlobalFilter(q || undefined);
    }, 200), []);
    function onChange(event) {
        var value = event.currentTarget.value;
        setInputValue(value);
        delayedQuery(value);
    }
    function onClick() {
        setOpen(!open);
        if (ref && ref.current) {
            ref.current.focus();
        }
    }
    function close() {
        if (!inputValue) {
            setOpen(false);
        }
    }
    function clear() {
        setInputValue('');
        delayedQuery.cancel();
        setGlobalFilter(undefined);
        setOpen(false);
    }
    return (jsxs("div", __assign({ ref: divRef, className: clsx(classes.root, open && classes.open) }, { children: [jsx(InputBase, { inputRef: ref, value: inputValue, onChange: onChange, className: clsx(classes.input, !open && classes.hide), placeholder: "Search in Table" }, void 0),
            !inputValue ? (jsx(Tooltip, __assign({ title: 'Search in Table' }, { children: jsx(IconButton, __assign({ onClick: onClick, className: classes.iconButton, "aria-label": "menu" }, { children: jsx(SearchIcon, { style: { fontSize: '20px' } }, void 0) }), void 0) }), void 0)) : (jsx(Tooltip, __assign({ title: 'Clear' }, { children: jsx(IconButton, __assign({ onClick: clear, className: classes.iconButton, "aria-label": "menu" }, { children: jsx(HighlightOffIcon, { style: { fontSize: '20px' } }, void 0) }), void 0) }), void 0))] }), void 0));
}

export default LocalGlobalFilter;
//# sourceMappingURL=LocalGlobalFilter.js.map
