import { useMemo } from 'react';

function useInstance(instance) {
    var totalColumnsWidth = instance.totalColumnsWidth, visibleColumns = instance.visibleColumns;
    var totalVisibleColumnsWidth = useMemo(function () {
        return totalColumnsWidth -
            visibleColumns
                .filter(function (column) { return column.isHidden; })
                .reduce(function (sum, column) { return (sum += Number(column.width)); }, 0);
    }, [totalColumnsWidth, visibleColumns]);
    Object.assign(instance, {
        totalVisibleColumnsWidth: totalVisibleColumnsWidth,
    });
}
var useHiddenColumn = function (hooks) {
    hooks.useInstance.push(useInstance);
};
useHiddenColumn.pluginName = 'useLocalStorageTable';

export { useHiddenColumn };
//# sourceMappingURL=useHiddenColumn.js.map
