import { _ as __assign } from '../../tslib.es6-a941f97f.js';
import { r as reactTable } from '../../index-b6c1b619.js';
import { useEffect } from 'react';
import '../../_commonjsHelpers-41cdd1e7.js';

function useInstance(instance) {
    var tableKey = instance.tableKey, _a = instance.state, hiddenColumns = _a.hiddenColumns, columnOrder = _a.columnOrder, columnResizing = _a.columnResizing;
    useEffect(function () {
        localStorage.setItem(tableKey + '_hiddenColumns', JSON.stringify(hiddenColumns));
    }, [hiddenColumns, tableKey]);
    useEffect(function () {
        localStorage.setItem(tableKey + '_columnOrder', JSON.stringify(columnOrder));
    }, [tableKey, columnOrder]);
    useEffect(function () {
        localStorage.setItem(tableKey + '_columnResizing', JSON.stringify(columnResizing));
    }, [tableKey, columnResizing]);
}
function reducer(state, action, previousState, instance) {
    var getDefaultResizingColumns = function () {
        var storageColumns = localStorage.getItem(instance.tableKey + "_columnResizing")
            ? JSON.parse(localStorage.getItem(instance.tableKey + "_columnResizing"))
            : undefined;
        if (storageColumns && typeof storageColumns === 'object')
            return storageColumns;
        return {
            columnWidths: {},
        };
    };
    if (action.type === reactTable.actions.init) {
        return __assign(__assign({}, state), { columnResizing: getDefaultResizingColumns() });
    }
    if (action.type === reactTable.actions.resetResize) {
        return __assign(__assign({}, state), { columnResizing: getDefaultResizingColumns() });
    }
}
var useLocalStorageTable = function (hooks) {
    hooks.useInstance.push(useInstance);
    hooks.stateReducers.push(reducer);
};
useLocalStorageTable.pluginName = 'useLocalStorageTable';

export { useLocalStorageTable };
//# sourceMappingURL=useLocalStorageTable.js.map
