import { _ as __assign } from '../tslib.es6-a941f97f.js';
import { jsxs, jsx } from 'react/jsx-runtime';
import { a as useFormikContext } from '../formik.esm-06fc6bc4.js';
import { l as lodash } from '../lodash-348e7dda.js';
import { F as FormControl, a as FormHelperText } from '../FormHelperText-9aa7662f.js';
import { _ as _extends } from '../extends-e61fd370.js';
import { _ as _objectWithoutPropertiesLoose } from '../objectWithoutPropertiesLoose-6856ddd5.js';
import { forwardRef, createElement, createContext, useContext, cloneElement, useRef, useImperativeHandle } from 'react';
import { p as propTypes } from '../index-df27ca20.js';
import { c as clsx } from '../clsx.m-6243b874.js';
import { g as generateUtilityClass, a as generateUtilityClasses, e as experimentalStyled, u as useThemeProps, c as composeClasses, d as deepmerge, s as shouldForwardProp, f as alpha, b as capitalize, j as useControlled, l as useForkRef } from '../experimentalStyled-9a0c9477.js';
import { u as useId } from '../useId-9539b538.js';
import { F as FormControlLabel } from '../FormControlLabel-5b89f3db.js';
import { S as SwitchBase } from '../SwitchBase-1231cda4.js';
import { a as createSvgIcon, c as createChainedFunction } from '../createSvgIcon-141865d4.js';
import { w as withStyles } from '../withStyles-6a29793a.js';
import { r as refType } from '../refType-2daf2908.js';
import { T as Typography } from '../Typography-cbcc1b4d.js';
import '../tiny-warning.esm-9caf1e37.js';
import '../hoist-non-react-statics.cjs-887936b4.js';
import '../_commonjsHelpers-41cdd1e7.js';
import '../utils-a2178b2f.js';
import '../FormControlContext-3e99c910.js';
import '../useFormControl-5a78d430.js';
import '../IconButton-ccfdb4cc.js';
import '../ButtonBase-fe35ba23.js';
import '../emotion-react.esm-10db94ea.js';
import '../assertThisInitialized-d8516fd7.js';
import '../inheritsLoose-8d9312ec.js';
import '../setPrototypeOf-38804714.js';
import '../TransitionGroupContext-99ee4842.js';
import '../elementTypeAcceptingRef-58d95132.js';
import '../useIsFocusVisible-7eb97459.js';
import '../makeStyles-3f0becbd.js';
import '../toConsumableArray-14d095fd.js';
import '../exactProp-2b7ae831.js';
import '../extendSxProp-f37d7304.js';

function getFormGroupUtilityClass(slot) {
  return generateUtilityClass('MuiFormGroup', slot);
}
generateUtilityClasses('MuiFormGroup', ['root', 'row']);

const overridesResolver$1 = (props, styles) => {
  const {
    styleProps
  } = props;
  return deepmerge(_extends({}, styleProps.row && styles.row), styles.root || {});
};

const useUtilityClasses$1 = styleProps => {
  const {
    classes,
    row
  } = styleProps;
  const slots = {
    root: ['root', row && 'row']
  };
  return composeClasses(slots, getFormGroupUtilityClass, classes);
};

const FormGroupRoot = experimentalStyled('div', {}, {
  name: 'MuiFormGroup',
  slot: 'Root',
  overridesResolver: overridesResolver$1
})(({
  styleProps
}) => _extends({
  /* Styles applied to the root element. */
  display: 'flex',
  flexDirection: 'column',
  flexWrap: 'wrap'
}, styleProps.row && {
  flexDirection: 'row'
}));
/**
 * `FormGroup` wraps controls such as `Checkbox` and `Switch`.
 * It provides compact row layout.
 * For the `Radio`, you should be using the `RadioGroup` component instead of this one.
 */

const FormGroup = /*#__PURE__*/forwardRef(function FormGroup(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiFormGroup'
  });

  const {
    className,
    row = false
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["className", "row"]);

  const styleProps = _extends({}, props, {
    row
  });

  const classes = useUtilityClasses$1(styleProps);
  return /*#__PURE__*/createElement(FormGroupRoot, _extends({
    className: clsx(classes.root, className),
    styleProps: styleProps,
    ref: ref
  }, other));
});
process.env.NODE_ENV !== "production" ? FormGroup.propTypes = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------

  /**
   * The content of the component.
   */
  children: propTypes.node,

  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypes.object,

  /**
   * @ignore
   */
  className: propTypes.string,

  /**
   * Display group of elements in a compact row.
   * @default false
   */
  row: propTypes.bool,

  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypes.object
} : void 0;

/**
 * @ignore - internal component.
 */

var RadioButtonUncheckedIcon = createSvgIcon( /*#__PURE__*/createElement("path", {
  d: "M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.42 0-8-3.58-8-8s3.58-8 8-8 8 3.58 8 8-3.58 8-8 8z"
}), 'RadioButtonUnchecked');

/**
 * @ignore - internal component.
 */

var RadioButtonCheckedIcon = createSvgIcon( /*#__PURE__*/createElement("path", {
  d: "M8.465 8.465C9.37 7.56 10.62 7 12 7C14.76 7 17 9.24 17 12C17 13.38 16.44 14.63 15.535 15.535C14.63 16.44 13.38 17 12 17C9.24 17 7 14.76 7 12C7 10.62 7.56 9.37 8.465 8.465Z"
}), 'RadioButtonChecked');

const styles = theme => ({
  root: {
    position: 'relative',
    display: 'flex',
    '&$checked $dot': {
      transform: 'scale(1)',
      transition: theme.transitions.create('transform', {
        easing: theme.transitions.easing.easeOut,
        duration: theme.transitions.duration.shortest
      })
    }
  },
  checked: {},
  background: {
    // Scale applied to prevent dot misalignment in Safari
    transform: 'scale(1)'
  },
  dot: {
    left: 0,
    position: 'absolute',
    transform: 'scale(0)',
    transition: theme.transitions.create('transform', {
      easing: theme.transitions.easing.easeIn,
      duration: theme.transitions.duration.shortest
    })
  }
});
/**
 * @ignore - internal component.
 */

function RadioButtonIcon(props) {
  const {
    checked,
    classes,
    fontSize
  } = props;
  return /*#__PURE__*/createElement("div", {
    className: clsx(classes.root, checked && classes.checked)
  }, /*#__PURE__*/createElement(RadioButtonUncheckedIcon, {
    fontSize: fontSize,
    className: classes.background
  }), /*#__PURE__*/createElement(RadioButtonCheckedIcon, {
    fontSize: fontSize,
    className: classes.dot
  }));
}

process.env.NODE_ENV !== "production" ? RadioButtonIcon.propTypes = {
  /**
   * If `true`, the component is checked.
   */
  checked: propTypes.bool,

  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: propTypes.object.isRequired,

  /**
   * The size of the component.
   * `small` is equivalent to the dense radio styling.
   */
  fontSize: propTypes.oneOf(['small', 'medium'])
} : void 0;
var RadioButtonIcon$1 = withStyles(styles, {
  name: 'PrivateRadioButtonIcon'
})(RadioButtonIcon);

/**
 * @ignore - internal component.
 */

const RadioGroupContext = /*#__PURE__*/createContext();

if (process.env.NODE_ENV !== 'production') {
  RadioGroupContext.displayName = 'RadioGroupContext';
}

function useRadioGroup() {
  return useContext(RadioGroupContext);
}

function getRadioUtilityClass(slot) {
  return generateUtilityClass('MuiRadio', slot);
}
generateUtilityClasses('MuiRadio', ['root', 'checked', 'disabled', 'colorPrimary', 'colorSecondary']);

const overridesResolver = (props, styles) => {
  const {
    styleProps
  } = props;
  return deepmerge(styles.root || {}, styles[`color${capitalize(styleProps.color)}`]);
};

const useUtilityClasses = styleProps => {
  const {
    classes,
    color
  } = styleProps;
  const slots = {
    root: ['root', `color${capitalize(color)}`]
  };
  return _extends({}, classes, composeClasses(slots, getRadioUtilityClass, classes));
};

const RadioRoot = experimentalStyled(SwitchBase, {
  shouldForwardProp: prop => shouldForwardProp(prop) || prop === 'classes'
}, {
  name: 'MuiRadio',
  slot: 'Root',
  overridesResolver
})(({
  theme,
  styleProps
}) => _extends({
  /* Styles applied to the root element. */
  color: theme.palette.text.secondary
}, styleProps.color !== 'default' && {
  '&.Mui-checked': {
    color: theme.palette[styleProps.color].main,
    '&:hover': {
      backgroundColor: alpha(theme.palette[styleProps.color].main, theme.palette.action.hoverOpacity),
      // Reset on touch devices, it doesn't add specificity
      '@media (hover: none)': {
        backgroundColor: 'transparent'
      }
    }
  }
}, {
  '&.Mui-disabled': {
    color: theme.palette.action.disabled
  }
}));
const defaultCheckedIcon = /*#__PURE__*/createElement(RadioButtonIcon$1, {
  checked: true
});
const defaultIcon = /*#__PURE__*/createElement(RadioButtonIcon$1, null);
const Radio = /*#__PURE__*/forwardRef(function Radio(inProps, ref) {
  const props = useThemeProps({
    props: inProps,
    name: 'MuiRadio'
  });

  const {
    checked: checkedProp,
    color = 'secondary',
    name: nameProp,
    onChange: onChangeProp,
    size = 'medium'
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["checked", "color", "name", "onChange", "size"]);

  const styleProps = _extends({}, props, {
    color,
    size
  });

  const classes = useUtilityClasses(styleProps);
  const radioGroup = useRadioGroup();
  let checked = checkedProp;
  const onChange = createChainedFunction(onChangeProp, radioGroup && radioGroup.onChange);
  let name = nameProp;

  if (radioGroup) {
    if (typeof checked === 'undefined') {
      checked = radioGroup.value === props.value;
    }

    if (typeof name === 'undefined') {
      name = radioGroup.name;
    }
  }

  return /*#__PURE__*/createElement(RadioRoot, _extends({
    color: color,
    type: "radio",
    icon: /*#__PURE__*/cloneElement(defaultIcon, {
      fontSize: size === 'small' ? 'small' : 'medium'
    }),
    checkedIcon: /*#__PURE__*/cloneElement(defaultCheckedIcon, {
      fontSize: size === 'small' ? 'small' : 'medium'
    }),
    styleProps: styleProps,
    classes: classes,
    name: name,
    checked: checked,
    onChange: onChange,
    ref: ref
  }, other));
});
process.env.NODE_ENV !== "production" ? Radio.propTypes = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------

  /**
   * If `true`, the component is checked.
   */
  checked: propTypes.bool,

  /**
   * The icon to display when the component is checked.
   */
  checkedIcon: propTypes.node,

  /**
   * Override or extend the styles applied to the component.
   */
  classes: propTypes.object,

  /**
   * The color of the component. It supports those theme colors that make sense for this component.
   * @default 'secondary'
   */
  color: propTypes.oneOf(['default', 'primary', 'secondary']),

  /**
   * If `true`, the component is disabled.
   */
  disabled: propTypes.bool,

  /**
   * If `true`, the ripple effect is disabled.
   */
  disableRipple: propTypes.bool,

  /**
   * The icon to display when the component is unchecked.
   */
  icon: propTypes.node,

  /**
   * The id of the `input` element.
   */
  id: propTypes.string,

  /**
   * [Attributes](https://developer.mozilla.org/en-US/docs/Web/HTML/Element/input#Attributes) applied to the `input` element.
   */
  inputProps: propTypes.object,

  /**
   * Pass a ref to the `input` element.
   */
  inputRef: refType,

  /**
   * Name attribute of the `input` element.
   */
  name: propTypes.string,

  /**
   * Callback fired when the state is changed.
   *
   * @param {object} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   * You can pull out the new checked state by accessing `event.target.checked` (boolean).
   */
  onChange: propTypes.func,

  /**
   * If `true`, the `input` element is required.
   */
  required: propTypes.bool,

  /**
   * The size of the component.
   * `small` is equivalent to the dense radio styling.
   * @default 'medium'
   */
  size: propTypes.oneOf(['medium', 'small']),

  /**
   * The system prop that allows defining system overrides as well as additional CSS styles.
   */
  sx: propTypes.object,

  /**
   * The value of the component. The DOM API casts this to a string.
   */
  value: propTypes.any
} : void 0;

const RadioGroup = /*#__PURE__*/forwardRef(function RadioGroup(props, ref) {
  const {
    // private
    // eslint-disable-next-line react/prop-types
    actions,
    children,
    name: nameProp,
    value: valueProp,
    onChange
  } = props,
        other = _objectWithoutPropertiesLoose(props, ["actions", "children", "name", "value", "onChange"]);

  const rootRef = useRef(null);
  const [value, setValueState] = useControlled({
    controlled: valueProp,
    default: props.defaultValue,
    name: 'RadioGroup'
  });
  useImperativeHandle(actions, () => ({
    focus: () => {
      let input = rootRef.current.querySelector('input:not(:disabled):checked');

      if (!input) {
        input = rootRef.current.querySelector('input:not(:disabled)');
      }

      if (input) {
        input.focus();
      }
    }
  }), []);
  const handleRef = useForkRef(ref, rootRef);

  const handleChange = event => {
    setValueState(event.target.value);

    if (onChange) {
      onChange(event, event.target.value);
    }
  };

  const name = useId(nameProp);
  return /*#__PURE__*/createElement(RadioGroupContext.Provider, {
    value: {
      name,
      onChange: handleChange,
      value
    }
  }, /*#__PURE__*/createElement(FormGroup, _extends({
    role: "radiogroup",
    ref: handleRef
  }, other), children));
});
process.env.NODE_ENV !== "production" ? RadioGroup.propTypes = {
  // ----------------------------- Warning --------------------------------
  // | These PropTypes are generated from the TypeScript type definitions |
  // |     To update them edit the d.ts file and run "yarn proptypes"     |
  // ----------------------------------------------------------------------

  /**
   * The content of the component.
   */
  children: propTypes.node,

  /**
   * The default value. Use when the component is not controlled.
   */
  defaultValue: propTypes.oneOfType([propTypes.arrayOf(propTypes.string), propTypes.number, propTypes.string]),

  /**
   * The name used to reference the value of the control.
   * If you don't provide this prop, it falls back to a randomly generated name.
   */
  name: propTypes.string,

  /**
   * Callback fired when a radio button is selected.
   *
   * @param {object} event The event source of the callback.
   * You can pull out the new value by accessing `event.target.value` (string).
   */
  onChange: propTypes.func,

  /**
   * Value of the selected radio button. The DOM API casts this to a string.
   */
  value: propTypes.any
} : void 0;

var AppFormRadio = function (props) {
    var name = props.name, options = props.options, radioGroup = props.radioGroup;
    var validation = useFormikContext();
    var errors = validation.errors, touched = validation.touched;
    return (jsxs(FormControl, __assign({ error: !!lodash.get(errors, name) && !!lodash.get(touched, name) }, { children: [jsx(RadioGroup, __assign({ row: true, defaultValue: "top" }, radioGroup, { children: options.map(function (option, index) { return (jsx(FormControlLabel, { id: name, value: option.value, name: name, control: jsx(Radio, { color: "primary", checked: validation.values[name] === option.value, onClick: function () { return validation.setFieldValue(name, option.value); } }, void 0), label: jsx(Typography, __assign({ variant: "body1" }, { children: option.label }), void 0) }, index)); }) }), void 0),
            jsx(FormHelperText, { children: lodash.get(errors, name) && lodash.get(touched, name) && lodash.get(errors, name) }, void 0)] }), void 0));
};

export default AppFormRadio;
//# sourceMappingURL=AppFormRadio.js.map
