import { c as __rest, _ as __assign } from '../tslib.es6-a941f97f.js';
import { jsx } from 'react/jsx-runtime';
import AppTextField from './AppTextField.js';
import { a as useFormikContext } from '../formik.esm-06fc6bc4.js';
import { g as get_1 } from '../get-fc89bca9.js';
import { _ as _baseSet } from '../_baseSet-fa34e586.js';
import '../style-inject.es-1f59c1d0.js';
import '../TextField-41fe2395.js';
import '../extends-e61fd370.js';
import '../objectWithoutPropertiesLoose-6856ddd5.js';
import 'react';
import '../index-df27ca20.js';
import '../_commonjsHelpers-41cdd1e7.js';
import '../clsx.m-6243b874.js';
import '../withStyles-6a29793a.js';
import '../experimentalStyled-9a0c9477.js';
import '../hoist-non-react-statics.cjs-887936b4.js';
import '../makeStyles-3f0becbd.js';
import '../tiny-warning.esm-9caf1e37.js';
import '../toConsumableArray-14d095fd.js';
import '../inheritsLoose-8d9312ec.js';
import '../setPrototypeOf-38804714.js';
import '../assertThisInitialized-d8516fd7.js';
import '../exactProp-2b7ae831.js';
import '../refType-2daf2908.js';
import '../FormHelperText-9aa7662f.js';
import '../utils-a2178b2f.js';
import '../FormControlContext-3e99c910.js';
import '../createSvgIcon-141865d4.js';
import '../useFormControl-5a78d430.js';
import '../InputLabel-dec1cb11.js';
import '../Popover-16e53fc0.js';
import '../ownerDocument-08286491.js';
import '../isHostComponent-7b82e20e.js';
import '../ownerWindow-511cbe55.js';
import '../Grow-144e5c05.js';
import 'react-dom';
import '../TransitionGroupContext-99ee4842.js';
import '../elementTypeAcceptingRef-58d95132.js';
import '../Input-505624cb.js';
import '../InputBase-ac030ecb.js';
import '../emotion-react.esm-10db94ea.js';
import '../_MapCache-a3d3cd04.js';
import '../_isIndex-e6cb62f4.js';

/**
 * Sets the value at `path` of `object`. If a portion of `path` doesn't exist,
 * it's created. Arrays are created for missing index properties while objects
 * are created for all other missing properties. Use `_.setWith` to customize
 * `path` creation.
 *
 * **Note:** This method mutates `object`.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to modify.
 * @param {Array|string} path The path of the property to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns `object`.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.set(object, 'a[0].b.c', 4);
 * console.log(object.a[0].b.c);
 * // => 4
 *
 * _.set(object, ['x', '0', 'y', 'z'], 5);
 * console.log(object.x[0].y.z);
 * // => 5
 */
function set(object, path, value) {
  return object == null ? object : _baseSet(object, path, value);
}

var set_1 = set;

var AppValidateField = function (props) {
    var validation = useFormikContext();
    var errors = validation.errors, touched = validation.touched, handleBlur = validation.handleBlur, handleChange = validation.handleChange, values = validation.values, status = validation.status, setStatus = validation.setStatus;
    var name = props.name || 'name';
    var error = get_1(touched, name)
        ? get_1(status, name) || get_1(errors, name)
        : '';
    var helperText = props.helperText, otherProps = __rest(props, ["helperText"]);
    function onChange(event) {
        var _a, _b;
        var max = (_b = (_a = props.InputProps) === null || _a === void 0 ? void 0 : _a.inputProps) === null || _b === void 0 ? void 0 : _b.max;
        if (props.type === 'number' &&
            max &&
            Number(event.target.value) > Number(max))
            return;
        var newStatus = __assign({}, status);
        if (get_1(status, name)) {
            set_1(newStatus, name, '');
            setStatus(newStatus);
        }
        handleChange(event);
    }
    return (jsx(AppTextField, __assign({ name: name, error: !!error, onChange: onChange, onBlur: handleBlur, value: get_1(values, name), helperText: error ? error : helperText }, otherProps), void 0));
};

export default AppValidateField;
//# sourceMappingURL=AppValidateField.js.map
