import { r as react } from './index-80be40fc.js';

function useOnClickOutside(ref, handler) {
    react.useEffect(function () {
        var listener = function (event) {
            if (!ref.current || ref.current.contains(event.target)) {
                return;
            }
            handler(event);
        };
        document.addEventListener('mousedown', listener);
        document.addEventListener('touchstart', listener);
        return function () {
            document.removeEventListener('mousedown', listener);
            document.removeEventListener('touchstart', listener);
        };
    }, [ref, handler]);
}

export { useOnClickOutside as u };
//# sourceMappingURL=useOnClickOutside-e9c00043.js.map
